// PROVisionDlg.cpp : implementation file
//
#include "stdafx.h"
#include "ProVision.h"
#include "ProVisionDlg.h"
#include "SelectDSP.h"
#include "settingsDlg.h"
#include "server.h"
#include "Prosdk.h"

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <stdio.h>
#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_MYCOMMAND (WM_USER+1000)  // 

#define DIALTYPE	0	//dialing
#define NORMATYPE	1	//Wan or Lan

#define UPDATE_COUNTERS		__T("Update Frame Counters")
#define DATA_READY			__T("Data ready")

BOOL bCapture = FALSE;

unsigned char StreamBuf[1000000];

int __cdecl StreamReadCallback(ULONG ChannelNum, void *Context);
typedef int (*STREAM_DIRECT_READ_CALLBACK)(ULONG channelNumber,void *DataBuf,DWORD Length,int FrameType,void *context);
int __cdecl StreamDirectReadCallback(ULONG channelNumber,void *DataBuf,DWORD Length,int FrameType,void *context);


unsigned char FileHeader[64][200];
int FileHeaderLen = 0;
int    gFileHandleQcif[MAX_CHANNELS];

int icount = 0;;

int KeyFrameInterva[10] = {25,67,76,100,100,100,100,121,211,211};
int FrameRate[10] = {25,25,25,25,20,10,5,4,3,2};
int IQ[10] = {10,10,12,15,18,20,20,22,24,24};
int PQ[10] = {10,10,12,15,18,20,20,22,24,24};
int BQ[10] = {10,15,15,20,21,23,23,25,27,27};
int nowstate[16];


int servertype;

UINT usframe = 0;

BOOL chantype = FALSE;

DWORD dcurrentwin=0;
int g_nChannelTotal;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

int SplitRects(int width, int height, int cols, int rows, RECT *rectList);

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPROVisionDlg dialog

CPROVisionDlg::CPROVisionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPROVisionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPROVisionDlg)
	m_brightness = 0;
	m_contrast = 0;
	m_hue = 0;
	m_saturation = 0;
	m_iframes = 0;
	m_pbframes = 0;
	m_lostframes = 0;
	m_audioframes = 0;
	m_ip = _T("");
	m_sframe = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPROVisionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPROVisionDlg)
	DDX_Slider(pDX, IDC_SLIDER_BRIGHT, m_brightness);
	DDX_Slider(pDX, IDC_SLIDER_CONTRAST, m_contrast);
	DDX_Slider(pDX, IDC_SLIDER_HUE, m_hue);
	DDX_Slider(pDX, IDC_SLIDER_SAT, m_saturation);
	DDX_Text(pDX, IDC_IFRAMES, m_iframes);
	DDX_Text(pDX, IDC_PBFRAMES, m_pbframes);
	DDX_Text(pDX, IDC_LOST_FRAMES, m_lostframes);
	DDX_Text(pDX, IDC_AUDIOFRAMES, m_audioframes);
	DDX_Text(pDX, IDC_IP, m_ip);
	DDX_Check(pDX, IDC_CAPTURESFRAME, m_sframe);
	//}}AFX_DATA_MAP
}

static const UINT MsgUpdateCounters = ::RegisterWindowMessage(UPDATE_COUNTERS);
static const UINT MsgDataReady = ::RegisterWindowMessage(DATA_READY);

BEGIN_MESSAGE_MAP(CPROVisionDlg, CDialog)
	ON_MESSAGE(WM_MYCOMMAND,OnMyCommand)
	//{{AFX_MSG_MAP(CPROVisionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PREVIEW, OnPreview)
	ON_WM_CTLCOLOR()
	ON_WM_SHOWWINDOW()
	ON_WM_MOVE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_SETTINGS, OnSettings)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CAPIMAGE, OnCapimage)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_CAPTURESFRAME, OnCapturesframe)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_SUBSTART, OnSubstart)
	ON_REGISTERED_MESSAGE(MsgUpdateCounters, OnUpdateCounters)
	ON_REGISTERED_MESSAGE(MsgDataReady, OnDataReady)
	ON_BN_CLICKED(IDC_STOPSUBCAP, OnStopsubcap)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPROVisionDlg message handlers
int LogWrite(const char *Format, ...);

HANDLE ChannelHandle[MAX_CHANNELS];
//int    logFile;
int    gFileHandle[MAX_CHANNELS];
BOOLEAN dlgInited = FALSE;
HWND gMainWnd;
RECT rectList[MAX_CHANNELS];
BOOL bDdrawMode = FALSE;
ULONG   gChannelFrames[MAX_CHANNELS];
ULONG   gChannelTotalLength[MAX_CHANNELS];
ULONG	gChannelFramesLost[MAX_CHANNELS];
ULONG	gChannelOverflow[MAX_CHANNELS];
ULONG	gCurrentFileLen[MAX_CHANNELS];
ULONG	gCaptureStartedNum = 0;
UINT    gTimer;
UINT    gCapImages;
ULONG	gFileSize = 100; // 100 mb
int		gFileNum = 0;

COLORREF gBackgroundColor = RGB(10, 10, 10);
extern int iLastSelect;

ULONG StartTime;
ULONG LastTime;
///add ver3.4 by h
//int    gFileHandleQcif[MAX_CHANNELS];					//ͨͬʱʱqcif¼ļ
unsigned char FileHeaderQcif[MAX_CHANNELS][200];		//QCIF Header,when 
BOOL bEncodeCifAndQcif[MAX_CHANNELS];					//ͨͬʱʱͨ־


void CALLBACK StartCap(int port)
{
	StartVideoCapture(ChannelHandle[port]);	
}


void CALLBACK StopCap(int port)
{
	StopVideoCapture(ChannelHandle[port]);
}

int CALLBACK CheckIP(DWORD nChannel,char* nIP)
{
/*
	CString ctemp;
	ctemp.Format("%s",nIP);

	if (ctemp == "192.0.0.215")
		return -1;
*/
	return 0;

}

int CALLBACK checkpassword(char *username,WORD namelen,char *password,WORD passlen)
{
/*
	if ((username[0] == '1') && (username[1] == '2') && (username[2] == '3') && (password[0] == 'w'))
		return 0;
	else
		return -1;
*/
	return 0;

}


void CALLBACK SetIBP(int port,int framerat)
{
	SetIBPMode(ChannelHandle[port],211,2,2,framerat);
}

void CALLBACK MakeIFrame(int port)
{
	CaptureIFrame(ChannelHandle[port]);
}


BOOL CPROVisionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	int i;


	servertype = NORMATYPE;
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	m_brush1.CreateSolidBrush(gBackgroundColor);   
	m_brush2.CreateSolidBrush(RGB(0,0,0));   
	m_bLog = FALSE;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_brightness = 50;
	m_contrast = 50;
	m_hue = 0;
	m_saturation = 50;
	m_iframes = 0;
	m_pbframes = 0;
	m_audioframes = 0;
	m_lostframes = 0;

	for(i = 0; i < GetTotalDSPs(); i++){
		m_bDspPreset[i] = TRUE;
		bEncodeCifAndQcif[i] = FALSE;
		gFileHandle[i] = -1;
	}
	m_sframe = FALSE;

	UpdateData(FALSE);

	if(InitDSPs() < 0){
		//afxDump<<"error:can not init DSPs\n";
		AfxMessageBox("can not init DSPs\n");
		return FALSE;
	}

	CString title;
	CString dsps;
	dsps.Format("    %d channels Found", GetTotalDSPs());
	GetWindowText(title);
	title += dsps;
	SetWindowText(title);

	dlgInited = TRUE;

	m_VideoWin.SubclassDlgItem(IDC_VIDEOWIN, this);

	for(i = 0; i < GetTotalDSPs(); i++)
	{
		ChannelHandle[i] = ChannelOpen(i);
		if (ChannelHandle[i]<0) 
		{
			AfxMessageBox("channel open error > 0");

		}
		else if (ChannelHandle[i] ==(HANDLE) 0xffff)
		{
			AfxMessageBox("channel open error 0xffff");

		}

		gChannelTotalLength[i] = 0;
		nowstate[i]=0;

		if (servertype == DIALTYPE)
		{
			SetIBPMode(ChannelHandle[i],211,2,1,8);
			SetDefaultQuant(ChannelHandle[i],18,18,23);
			SetStreamType(ChannelHandle[i],STREAM_TYPE_VIDEO);
		}
		else
		{
			SetIBPMode(ChannelHandle[i],100,2,1,25);
			SetDefaultQuant(ChannelHandle[i],15,15,20);
		}
	}

	if (servertype == DIALTYPE)
	{
		for(i = 0; i < GetTotalDSPs(); i++)
			SetEncoderPictureFormat(ChannelHandle[i], ENC_QCIF_FORMAT);

	}
	else
	{

		for(i = 0; i < GetTotalDSPs(); i++)
		{
			if ( i==0 )
			{
				//when initiated,set the first channel as 4CIF encode,others as CIF
				SetEncoderPictureFormat(ChannelHandle[0], ENC_4CIF_FORMAT);
				bEncodeCifAndQcif[0] = FALSE;
			}
			else
			{
				SetEncoderPictureFormat(ChannelHandle[i], ENC_CIF_FORMAT);
			}

		}

	}

//	int id = IDC_CHECK2;
//	for(i = 0; i < MAX_CHANNELS; i++){
//		GetDlgItem(id + i)->EnableWindow(FALSE);
//	}
	RegisterStreamDirectReadCallback(::StreamDirectReadCallback,this);
	RegisterMessageNotifyHandle(m_hWnd, MsgDataReady);


	MP4_ServerSetMessage(WM_MYCOMMAND,this->m_hWnd);

	gCapImages = 0;

	SetOverlayColorKey(gBackgroundColor);

	gTimer = SetTimer(1, 1000, 0);
	SetTimer(2,2000,0);
	SetTimer(5,5000,0);

	for (i=0;i<MAX_CHANNELS;i++)
		gCurrentFileLen[i] = 0;

	SERVER_VIDEOINFO videoinfo;
	g_nChannelTotal = GetTotalDSPs();

	for( i=0 ; i < g_nChannelTotal; i++ )
	{
		if(i == 0)
		{
			MP4_ServerSetBufNum(i,90);
		}
		else
		{
			MP4_ServerSetBufNum(i,80);
		}
		
		if (servertype == DIALTYPE)
			videoinfo.m_datatype[i] = DIALING;
		else
			videoinfo.m_datatype[i] = NORMAL;
	}

	videoinfo.m_datatype[0] = SMALLPIC;

	videoinfo.m_channum = g_nChannelTotal;
	videoinfo.m_waittime = 2;

	MP4_ServerSetStart(StartCap);
	MP4_ServerSetStop(StopCap);

	MP4_ServerSetIBPMode(SetIBP);
	MP4_ServerSetCapIFrame(MakeIFrame);

	MP4_ServerSetTTL(64);
	MP4_ServerSetNetPort(5050,6050);

	MP4_ServerCheckIP(CheckIP);
	MP4_ServerCheckPassword(checkpassword);

	//set the max connector of  channel 0
	MP4_ServerMaxUser(0,24);

	//벻ʹȱʡʽжಥ
	//ԵĺԼĶಥϢ
	//ϸϢοSDKĵ
//	MP4_ServerCastGroup(TRUE,0,"228.0.0.132",9988);

	if (!MP4_ServerStart(&videoinfo))
	{
		MessageBox("error","error",MB_OK);
	}

	StartTime = timeGetTime();


	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPROVisionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPROVisionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPROVisionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



int LogWrite(const char *Format, ...)
{
	return 1;

	CHAR	Buffer0[1024];
	CHAR	Buffer1[512];
	DWORD	ItemsWritten;
	va_list	ArgumentList;

//	if(logFile == -1)return -1;

	SYSTEMTIME sysTime;
	GetLocalTime(&sysTime);

	sprintf(Buffer0, "%02d%02d:%02d:%02d:%02d:", sysTime.wMonth, sysTime.wDay, sysTime.wHour, 
		sysTime.wMinute, sysTime.wSecond);

	va_start ( ArgumentList, Format ); 
	ItemsWritten = vsprintf ((char *)Buffer1, Format, ArgumentList );
	va_end ( ArgumentList );
	strcat(Buffer0, Buffer1);


//	return _write ( logFile, Buffer0, strlen((const char *)Buffer0 ));
}


void CPROVisionDlg::OnStart() 
{

	// TODO: Add your control notification handler code here
	CSelectDSP selDialog;
	selDialog.DSPPreset(m_bDspPreset, GetTotalDSPs());

//	if(selDialog.DoModal() == IDOK){
	{
//		TRACE("SelectDSP:OK button clicked\n");
		selDialog.GetDSPsChoiced(m_bDspPreset);

		CString str;
		str.Format("%d", 0);
		GetDlgItem(IDC_LOST_FRAMES)->SetWindowText((LPCTSTR)str);
		GetDlgItem(IDC_TOTALFRAMES)->SetWindowText((LPCTSTR)str);
		GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)str);
//		GetDlgItem(IDC_FPS)->SetWindowText((LPCTSTR)str);

		LogWrite("start capture\n"); 

		for(int i = 0; i < GetTotalDSPs(); i++){
			m_bDspPreset[i]=TRUE;
			if(m_bDspPreset[i]){
				char fileName[256];

				sprintf(fileName, "d:\\stream%d_%d.264", i, gFileNum++/GetTotalDSPs());

				gFileHandle[i] = _open(fileName, _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
				if(gFileHandle[i] == -1){
					TRACE("channel %d file open error\n,i");
					return;
				}

				gChannelFrames[i] = 0;
				gChannelTotalLength[i] = 0;
				gChannelFramesLost[i] = 0;
				gChannelOverflow[i] = 0;
				gCurrentFileLen[i] = 0;

				_write(gFileHandle[i], FileHeader[i], FileHeaderLen);



				// could not be start again untill stopped first
				//m_bDspPreset[i] = FALSE;
				gCaptureStartedNum++;
				// let the threads have chance to run
				//Sleep(500);
			}else
				gFileHandle[i] = -1;
		}
		StartTime = timeGetTime();
		LastTime = timeGetTime();
		if(gCaptureStartedNum){
			GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
			GetDlgItem(IDC_START)->EnableWindow(FALSE);
			GetDlgItem(IDC_SETTINGS)->EnableWindow(FALSE);
		}
	}
/*
	StartVideoCapture(ChannelHandle[0]);	
	bCapture = TRUE;
*/
}

void CPROVisionDlg::LogMessage(const unsigned char *buf, void *context)
{
	if(!IsWindow(this->m_hWnd))return;

	int len = m_Logwin.GetWindowTextLength();

	CString str;
	 
	if (len >= 16384)
	{
		m_Logwin.GetWindowText(str);
		m_Logwin.SetWindowText(str.GetBuffer(len)+16384);
		len -= 16384;
	}

	str = buf;

	m_Logwin.SetSel(len, len);

	m_Logwin.ReplaceSel(str);

}

void CPROVisionDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	bCapture = FALSE;
	MP4_ServerStop();
	m_bLog = FALSE;
	KillTimer(gTimer);
	if(gCaptureStartedNum)
		OnStop();

	gCaptureStartedNum = 0;

	DeInitDSPs();	
//	_close(logFile);
	CDialog::OnClose();
}



void CPROVisionDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	CSelectDSP selDialog;
	selDialog.DSPPreset(m_bDspPreset, GetTotalDSPs());

//	bCapture = FALSE;

//	if(selDialog.DoModal() == IDOK){
	{
		LogWrite("Stop capture\n");
//		TRACE("SelectDSP:OK button clicked\n");
		selDialog.GetDSPsChoiced(m_bDspPreset);
		for(int i = 0; i < GetTotalDSPs(); i++){
			if(m_bDspPreset[i]){
				ASSERT(gFileHandle[i] != -1);
//				StopVideoCapture(ChannelHandle[i]);
				//lseek(gFileHandle[i], 0, SEEK_SET);
				//FRAMES_STATISTICS fs;
				//GetFramesStatistics(ChannelHandle[i], &fs);
				//ULONG frames = fs.AudioFrames + fs.VideoFrames;
				//TRACE("channel %i has %x frames written\n", i, frames);
#define END_CODE 0x00000002
				ULONG endCode = END_CODE;
				_write(gFileHandle[i], &endCode, sizeof(ULONG));
				_close(gFileHandle[i]);
///add v34
				if (bEncodeCifAndQcif[i])
					_close(gFileHandleQcif[i]);
				gCaptureStartedNum--;
			}
		}

		if(!gCaptureStartedNum){
			GetDlgItem(IDC_START)->EnableWindow(TRUE);
			GetDlgItem(IDC_SETTINGS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
		}
	}
}

void CPROVisionDlg::StartVideoPreview()
{
}

void CPROVisionDlg::StopVideoPreview()
{
//	TRACE("StopVideoPreview\n");
	for(int i = 0; i < GetTotalDSPs(); i++){
		::StopVideoPreview(ChannelHandle[i]);
	}
}

void CPROVisionDlg::OnPreview() 
{
/*
	// TODO: Add your control notification handler code here
	static BOOLEAN bVideoStarted = FALSE;
	if(bVideoStarted){
		StopVideoPreview();
		bVideoStarted = FALSE;
	}else{
		StartVideoPreview();
		bVideoStarted = TRUE;
	}
*/

//////Ϊʾ

	char ctemp[256];
	sprintf(ctemp,"192.0.0.214");
	MP4_ServerStringToClient((LPCTSTR)ctemp,"receive",7);

}




HBRUSH CPROVisionDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	if((nCtlColor== CTLCOLOR_EDIT) && (pWnd->GetDlgCtrlID() == IDC_EDIT1)){
		pDC->SetTextColor (RGB (255, 0 , 0));
		pDC->SetBkColor(gBackgroundColor);
		hbr = (HBRUSH) m_brush1;
	}

	if((nCtlColor== CTLCOLOR_EDIT) && (pWnd->GetDlgCtrlID() == IDC_LOGWIN)){
		pDC->SetTextColor (RGB (255, 0 , 0));
		pDC->SetBkColor(RGB(0, 0, 0));
//		pDC->SetBkColor(RGB(255, 0, 255));
		hbr = (HBRUSH) m_brush2;
	}
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CPROVisionDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
//	TRACE("Onshowwindow m_hwnd is %x\n", m_hWnd);

	m_bLog = TRUE;


}

void CPROVisionDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);

	if(!dlgInited)return;  
	
	// TODO: Add your message handler code here

	::SendMessage(GetDlgItem(IDC_VIDEOWIN)->m_hWnd, WM_PAINT, 0, 0);

	
}


void CPROVisionDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPROVisionDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
/*	// TODO: Add your message handler code here and/or call default
	int bright, contrast, sat, hue, standard;
	
	if((GetDlgItem(IDC_SLIDER_BRIGHT) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		for(int i = 0; i < GetTotalDSPs(); i++){
			GetVideoPara(ChannelHandle[i], &standard, &bright, &contrast, &sat, &hue);
			bright = (nPos * 255) / 100;
/			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}

	if((GetDlgItem(IDC_SLIDER_CONTRAST) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		for(int i = 0; i < GetTotalDSPs(); i++){
			GetVideoPara(ChannelHandle[i], &standard, &bright, &contrast, &sat, &hue);
			contrast = (nPos * 127) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}

	if((GetDlgItem(IDC_SLIDER_SAT) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		for(int i = 0; i < GetTotalDSPs(); i++){
			GetVideoPara(ChannelHandle[i], &standard, &bright, &contrast, &sat, &hue);
			sat = (nPos * 127) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}

	if((GetDlgItem(IDC_SLIDER_HUE) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		for(int i = 0; i < GetTotalDSPs(); i++){
			GetVideoPara(ChannelHandle[i], &standard, &bright, &contrast, &sat, &hue);
			hue = (nPos * 255) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}
*/

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}





int CPROVisionDlg::OnUpdateCounters(UINT wparam, INT lparam)
{
	CString str;
	str.Format("%i", wparam);
	GetDlgItem(IDC_IFRAMES)->SetWindowText((LPCTSTR)str);
	
	return 0;
}



void CPROVisionDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnLButtonDown(nFlags, point);
}



int CPROVisionDlg::OnDataReady(UINT channelNum, INT lparam)
{
	ULONG length = 1000000;
	int frameType;
	int status,i;
	BOOL breakable;
	CString ctip;
	int nframetype =0;

	// if cap images we need clean the queue here
//	if (!bCapture)
//		return 0;
	
	 status = ReadStreamData(ChannelHandle[channelNum], StreamBuf,  &length, &frameType);


	 // error occured
	 if(status < 0){
		 TRACE("error:ReadStreamData %x\n", status);
		 return 0;
	 }
///add v34 
// nframetype value:	 1 cif head; 2 qcif head; 3 cif frame; 4 qcif frame; 5 audio frame; 0 others
//CIFQICFͬʱʱҪֱͨ
// CIFݴCIFļУQCIFݴQCIFļУƵҪֱ洢
//	 if (bEncodeCifAndQcif[channelNum])
//		nframetype = GetSubChannelStreamType(&StreamBuf,frameType);

	 breakable = status;
	 // no errors
	 if(frameType > 0) {
		 if(frameType == PktSysHeader){
			 if (bEncodeCifAndQcif[channelNum])
			 {
				 if (nframetype == 1)  //get cif file header
				 {
					memcpy(FileHeader[channelNum],StreamBuf,length);
					FileHeaderLen = length;
				 }
				 else if (nframetype ==2)	//get qcif or qqcif file header
				 {
					memcpy(FileHeaderQcif[channelNum], StreamBuf, length);
					TRACE("Ch%02d get Qcifhead or QQcifhead!\n",channelNum);
					FileHeaderLen = length;
				 }
			 }
			 else{
			 TRACE("channel %d get the file header !\n",channelNum);
			 // store the file header
			 memcpy(FileHeader[channelNum], StreamBuf, length);
			 FileHeaderLen = length;
			 }
		 }
		 if(frameType == PktMotionDetection){
			 m_VideoWin.DrawVect(channelNum, (char *)StreamBuf, length);
			 return 0;
		 }
		 if(frameType == PktOrigImage){
			 return 0;
		 }


	 }

	 if(length == 0){
		 TRACE("no data ?\n");
		 return 0;
	 }

	 if(frameType == PktIFrames){
		 int iii=1;
	 }

	ULONG currentTime = timeGetTime();

	gChannelTotalLength[channelNum] += length;
	gCurrentFileLen[channelNum] += length;

	if(currentTime > StartTime+1000){

		CString str,str2;
		str.Format("%d", (gChannelTotalLength[dcurrentwin] *8/(currentTime - StartTime)));
		for(i=0;i<g_nChannelTotal;i++)
			gChannelTotalLength[i] = 0;
		 StartTime= currentTime; 
		GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)str);
	}



/*
	if((gCurrentFileLen[wparam] > gFileSize * 1000 * 1000) && breakable){
		TRACE("switch file:frametype=%x\n", frameType);
		_close(gFileHandle[wparam]);
		// create new file
		char fileName[256];
		sprintf(fileName, "stream%d_%d.mp4", wparam, gFileNum++/GetTotalDSPs());
		gFileHandle[wparam] = _open(fileName, _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
		// write the header first
		_write(gFileHandle[wparam], FileHeader, FileHeaderLen);
		gCurrentFileLen[wparam] -= gFileSize * 1000 * 1000;
	}
*/

		if(frameType ==PktAudioFrames)
		{
			_write(gFileHandleQcif[channelNum],StreamBuf,length);
			MP4_ServerWriteDataEx(channelNum,(unsigned char *)StreamBuf, length,frameType,status,1);
			_write(gFileHandle[channelNum], StreamBuf, length);
			MP4_ServerWriteDataEx(channelNum,(unsigned char *)StreamBuf, length,frameType,status,0);
			
		}else if (frameType ==PktSubIFrames || frameType ==PktSubPFrames || frameType == PktSubBBPFrames || frameType == PktSubSysHeader)
		{
			_write(gFileHandleQcif[channelNum],StreamBuf,length);
			MP4_ServerWriteDataEx(channelNum,(unsigned char *)StreamBuf, length,frameType,status,1);	
		}else 
		{
			_write(gFileHandle[channelNum], StreamBuf, length);
			MP4_ServerWriteDataEx(channelNum,(unsigned char *)StreamBuf, length,frameType,status,0);
		}
	return 0;
}

void CPROVisionDlg::OnSettings() 
{

	// TODO: Add your control notification handler code here
	int i;
	CSettingsDlg dlg;
	int nResponse = dlg.DoModal();

	if (nResponse == IDOK){
//		TRACE("quant = %d file size = %d streamType = %d\n",
//			dlg.m_Quant, dlg.m_FileSize , dlg.m_StreamType);
		// setup quant value 
	USHORT Format1[40] = {48, 16, 'P','r','o','V', 'i','d','e','o',' ',' ',' ','M','u','l','t','i','m','e','d','i','a','\0'};
	USHORT Format2[40] = {24, 50, _OSD_YEAR4, '-',_OSD_MONTH2,'-',_OSD_DAY,'-',  _OSD_HOUR24, ':', _OSD_MINUTE,':', _OSD_SECOND, '\0'};
	PictureFormat_t encodeType ;

	for( i = 0; i < GetTotalDSPs(); i++){
				StopVideoCapture(ChannelHandle[i]);
				}
		
		switch(dlg.m_iEncodeType)
			{
			case 0:
				encodeType = ENC_4CIF_FORMAT;
				break;
			case 1:
				encodeType = ENC_2CIF_FORMAT;
				break;
			case 2:
				encodeType = ENC_DCIF_FORMAT;
				break;
			case 3:
				encodeType = ENC_CIF_FORMAT;
				break;
			case 4:
				encodeType = ENC_QCIF_FORMAT;
				break;
			default:
				encodeType = ENC_CIF_FORMAT;
				break;
			}
			for(i = 0; i < GetTotalDSPs(); i++)
			{
				if(encodeType != ENC_4CIF_FORMAT)
				{					
					SetEncoderPictureFormat(ChannelHandle[i],encodeType);
				}
				else if ((i%4==0)||(i%4==1))
				{					
					SetEncoderPictureFormat(ChannelHandle[i],encodeType);
				}
			}

		for(i = 0; i < GetTotalDSPs(); i++){
			SetBitrateControlMode(ChannelHandle[i], dlg.m_bCbr ?brCBR  : brVBR );
		}

		for( i = 0; i < GetTotalDSPs(); i++)
		{
			if (!dlg.m_bCbr)
			{
				SetDefaultQuant(ChannelHandle[i], dlg.m_iQuant, dlg.m_pQuant, dlg.m_bQuant);
				SetupBitrateControl(ChannelHandle[i],dlg.m_dwbitrate);
			}
			else
				SetupBitrateControl(ChannelHandle[i],dlg.m_dwbitrate);
		}

		if(dlg.m_OsdEnable){
			for(i = 0; i < GetTotalDSPs(); i++){
				SetOsdDisplayMode(ChannelHandle[i], 255, TRUE, 0, Format1, Format2);
				SetOsd(ChannelHandle[i], TRUE);
			}
		}else {
			for(i = 0; i < GetTotalDSPs(); i++){
				SetOsd(ChannelHandle[i], FALSE);
			}
		}

		if(dlg.m_IFramesIntervals  < 12){
			AfxMessageBox("Invalid Key Frames Invervals\n");
			return;
		}else{
			if((dlg.m_FrameRate > 25) || (dlg.m_FrameRate <=0))
				dlg.m_FrameRate = 25;
			for( i = 0; i < GetTotalDSPs(); i++){
				SetIBPMode(ChannelHandle[i], dlg.m_IFramesIntervals, 2, 1, dlg.m_FrameRate);
			}
		}

		if(dlg.m_MotionDetect){
			for( i = 0; i < GetTotalDSPs(); i++){
				StartMotionDetection(ChannelHandle[i]);
			}
		}else{
			for( i = 0; i < GetTotalDSPs(); i++){
				StopMotionDetection(ChannelHandle[i]);
			}
		}


		USHORT streamType = STREAM_TYPE_AVSYNC;
		switch(dlg.m_StreamType){
		case 0:
			streamType = STREAM_TYPE_VIDEO;
			break;
		case 1:
			streamType = STREAM_TYPE_AUDIO;
			break;
		case 2:
			streamType = STREAM_TYPE_AVSYNC;
			break;
		}

		for(i = 0; i < GetTotalDSPs(); i++){
			SetStreamType(ChannelHandle[i], streamType);
		}

		if(dlg.m_logoEnable){
			int w,h;
			unsigned char *bitsBuffer = (unsigned char *)malloc(128 * 128 * 2);

			if(bitsBuffer == NULL)
				return;

			LoadYUVFromBmpFile("logo.bmp", bitsBuffer, 128 * 128 * 2,  &w, &h);


			for( i = 0; i < GetTotalDSPs(); i++){
				SetLogo(ChannelHandle[i], 0, 110, 128, 128, (UCHAR *)bitsBuffer);
				SetLogoDisplayMode(ChannelHandle[i], RGB(0,0,0),TRUE, 0);
				}

			free(bitsBuffer);
		}else{
			for( i = 0; i < GetTotalDSPs(); i++){
				StopLogo(ChannelHandle[i]);
			}
		}
		gFileSize = dlg.m_FileSize;

		for( i = 0; i < GetTotalDSPs(); i++){
			if(encodeType != ENC_4CIF_FORMAT)
			{					
				StartVideoCapture(ChannelHandle[i]);
			}
			else if ((i%4==0)||(i%4==1))
			{					
				StartVideoCapture(ChannelHandle[i]);
			}
			}
	
	}
}


void CPROVisionDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == 1)
	{
		for(int i = 0; i < GetTotalDSPs(); i++){
			if(!GetVideoSignal(ChannelHandle[i])){
				CheckDlgButton(IDC_CHECK2 + i, BST_CHECKED);   
			}else{
//				TRACE("Channel%d Video lost !\n", i);
				CheckDlgButton(IDC_CHECK2 + i, BST_UNCHECKED);   
			}
		}
	}
	else if (nIDEvent == 2)
	{
		CString str;
		WORD num;
		MP4_ServerGetState(&num);
		str.Format("%d",num);
		GetDlgItem(IDC_FPS)->SetWindowText((LPCTSTR)str);
	}
	else if (nIDEvent == 10)
	{
		CaptureIFrame(ChannelHandle[0]);
	}
//CPLAYER_API STATISTIC*    __stdcall  MP4_ServerGetStatistic(DWORD nChannel,int *returnnum); 

	CDialog::OnTimer(nIDEvent);
}

void CPROVisionDlg::OnCapimage() 
{
	// TODO: Add your control notification handler code here
}

void CPROVisionDlg::OnDestroy() 
{
	if (usframe)
		KillTimer(usframe);
	CDialog::OnDestroy();
}

void CPROVisionDlg::OnMyCommand(WPARAM wParam, LPARAM lParam)
{
	if ((BYTE)wParam == GETSTRING)
	{
		char ts[1000];
		char ips[30];
		WORD tlen;
		memset(ts,0,1000);
		MP4_ServerReadLastMessage(ips,ts,&tlen);
		sprintf(&(ts[tlen]),"\r\n");
		AfxMessageBox(ts);
//		TRACE(ts);
	}
}


void CPROVisionDlg::OnButton5() 
{
	MP4_ServerCommandToClient(20,0);
	
}

void CPROVisionDlg::OnButton6() 
{
	char sendcont[500];
	CString firstco;
	firstco = "0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789";
	int testnum=0;

	MP4_ServerSetWait(3000,5);
	UpdateData(TRUE);

//	for(int i=0;i<100;i++)
	{
		memset(sendcont,0,500);
		UpdateData(TRUE);
		sprintf(sendcont,"%s send content %d",firstco,testnum);
		testnum++;
		if (testnum > 200)
			testnum=0;
		MP4_ServerStringToClient(m_ip,sendcont,400);
		Sleep(100);
	}
	
}

void CPROVisionDlg::OnButton7() 
{
	MP4_ServerResetChannel(1);
}

void CPROVisionDlg::OnButton8() 
{
	MP4_ServerStringToClient_other(0,"123456789",10);
	
}

void CPROVisionDlg::OnCapturesframe() 
{
	UpdateData(TRUE);
	if (m_sframe)
	{
		usframe = SetTimer(10,1000,NULL);
	}
	else
	{
		if (usframe)
			KillTimer(usframe);
	}
	
}


void CPROVisionDlg::OnButton9() 
{
	if (chantype)
	{
		for(int i = 0; i < GetTotalDSPs(); i++)
		{
			StopVideoCapture(ChannelHandle[i]);
			MP4_ServerChangeChanType(i,NORMAL);
			SetIBPMode(ChannelHandle[i],211,2,2,25);
			SetDefaultQuant(ChannelHandle[i],15,15,20);
			SetEncoderPictureFormat(ChannelHandle[i], ENC_CIF_FORMAT);
			StartVideoCapture(ChannelHandle[i]);
		}	
		chantype = FALSE;

	}
	else
	{
		for(int i = 0; i < GetTotalDSPs(); i++)
		{
			StopVideoCapture(ChannelHandle[i]);
			MP4_ServerChangeChanType(i,DIALING);
			SetIBPMode(ChannelHandle[i],211,2,2,8);
			SetDefaultQuant(ChannelHandle[i],18,18,23);
			SetStreamType(ChannelHandle[i],STREAM_TYPE_VIDEO);
			SetEncoderPictureFormat(ChannelHandle[i], ENC_QCIF_FORMAT);
			StartVideoCapture(ChannelHandle[i]);
		}	
		chantype = TRUE;
	}
}

//typedef int (*STREAM_DIRECT_READ_CALLBACK)(ULONG channelNumber,void *DataBuf,DWORD Length,int FrameType,void *context);
int __cdecl StreamDirectReadCallback(ULONG channelNum,void *DataBuf,DWORD Length,int frameType,void *context)
{


	int i,status=0;
	CString ctip;
	int nframetype =0;

	// if cap images we need clean the queue here
//	if (!bCapture)
//		return 0;

	 // no errors
	 if(frameType > 0) {
		 if(frameType == PktSysHeader){	 
			 // store the file header			 
			 memcpy(FileHeader[channelNum], DataBuf, Length);
			 FileHeaderLen = Length;
			 TRACE("channel %d get the file header !\n",channelNum);
			
		 }

		 if(frameType == PktIFrames || frameType ==PktSubIFrames){
			 status = 1;
		 }
		 else{
			 status = 0;
		 }
			
		 if(frameType == PktMotionDetection){
//			 m_VideoWin.DrawVect(channelNum, (char *)DataBuf, Length);
			 return 0;
		 }
		 if(frameType == PktOrigImage){
			 return 0;
		 }


	 }

	 if(Length == 0){
		 TRACE("no data ?\n");
		 return 0;
	 }

//	 if(frameType == PktIFrames){
//		 int iii=1;
//	 }

	ULONG currentTime = timeGetTime();

	gChannelTotalLength[channelNum] += Length;
	gCurrentFileLen[channelNum] += Length;

	if(currentTime > StartTime+1000){

		CString str,str2;
		str.Format("%d", (gChannelTotalLength[dcurrentwin] *8/(currentTime - StartTime)));
		for(i=0;i<g_nChannelTotal;i++)
			gChannelTotalLength[i] = 0;
		 StartTime= currentTime; 
		CPROVisionDlg *pMain = (CPROVisionDlg *)AfxGetMainWnd();
		 pMain->GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)str);
	}

//	if (m_sframe && channelNum ==0)
//	{
 // 		 if((frameType == PktSFrames && nframetype ==4 )||(frameType == PktSysHeader))
//		 {
//			MP4_ServerWriteData(channelNum,(unsigned char *)DataBuf, Length,frameType,status);	
//		 }
//	}
	
//	MP4_ServerWriteData(channelNum,(unsigned char *)DataBuf, Length,frameType,status);	
	
	if(frameType ==PktAudioFrames)
	{
		_write(gFileHandleQcif[channelNum],DataBuf,Length);
		MP4_ServerWriteDataEx(channelNum,(unsigned char *)DataBuf, Length,frameType,status,1);
		_write(gFileHandle[channelNum], DataBuf, Length);
		MP4_ServerWriteDataEx(channelNum,(unsigned char *)DataBuf, Length,frameType,status,0);
		
	}else if (frameType ==PktSubIFrames || frameType ==PktSubPFrames || frameType == PktSubBBPFrames || frameType == PktSubSysHeader)
	{
		
		_write(gFileHandleQcif[channelNum],DataBuf,Length);
		MP4_ServerWriteDataEx(channelNum,(unsigned char *)DataBuf, Length,frameType,status,1);	
	}else 
	{
		_write(gFileHandle[channelNum], DataBuf, Length);
		MP4_ServerWriteDataEx(channelNum,(unsigned char *)DataBuf, Length,frameType,status,0);
	}

	return 0;
}

void CPROVisionDlg::OnSubstart() 
{
	// TODO: Add your control notification handler code here
	for(int i=0; i < GetTotalChannels(); i++)
	{
		char fileName[256];
		sprintf(fileName,"d:\\streamqcif%d_%d.264",i,gFileNum++);
		gFileHandleQcif[i]= _open(fileName,_O_CREAT|_O_BINARY|_O_WRONLY|_O_TRUNC,_S_IREAD|_S_IWRITE);
		if(gFileHandleQcif[i] ==-1)
		{
			TRACE("file Open error!\n");
			AfxMessageBox("can not open file!\n");
			return ;
		}
		SetSubStreamType(ChannelHandle[i],STREAM_TYPE_AVSYNC);
		SetSubEncoderPictureFormat(ChannelHandle[i],ENC_CIF_FORMAT);
		SetupSubChannel(ChannelHandle[i],1);// switch to sub channel for setting
		SetBitrateControlMode(ChannelHandle[i], brVBR );
		SetupBitrateControl(ChannelHandle[i],2000000);
		SetDefaultQuant(ChannelHandle[i], 16, 16, 18);
		SetIBPMode(ChannelHandle[i],100,2,2,25);
		StartSubVideoCapture(ChannelHandle[i]);
		SetupSubChannel(ChannelHandle[i],0);//switch to main channel 
	}
	GetDlgItem(IDC_SUBSTART)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPSUBCAP)->EnableWindow(TRUE);
}

void CPROVisionDlg::OnStopsubcap() 
{
	// TODO: Add your control notification handler code here
	for(int i=0; i < GetTotalChannels(); i++)
	{
		StopSubVideoCapture(ChannelHandle[i]);
	}
	GetDlgItem(IDC_SUBSTART)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOPSUBCAP)->EnableWindow(FALSE);
}
