// PlayerDlg.h : header file
//

#if !defined(AFX_PLAYERDLG_H__BC7E7078_7E67_40B3_85A4_591E51BB1A4A__INCLUDED_)
#define AFX_PLAYERDLG_H__BC7E7078_7E67_40B3_85A4_591E51BB1A4A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include"seek.h"
#include"displayRect.h"
/////////////////////////////////////////////////////////////////////////////
// CPlayerDlg dialog

class CPlayerDlg : public CDialog
{
// Construction
public:
	void SetWindowSize();
	int m_nScreenHeight;
	INT m_nScreenWidth;
	CRect m_rcOnWnd;
	CRect GetOnPicRect(CRect rcWnd,CRect rcOnWnd,LONG nPicWidth,LONG nPicHeight);
	
	void CheckDisplayType(DWORD nID);
	
	void CheckThrowBFrame(UINT nMenuID);
	CPlayerDlg(CWnd* pParent = NULL);	// standard constructor
	void ChangeUI();
	void SetCloseState();
	void SetOpenState();
	void CloseStream();
	void TestCapability(DWORD nDeviceNum);
	BOOL OpenStream();
	void DrawStatus();
	void CloseFile();
	void OpenFile();
	void InitWindowSize(DWORD cx,DWORD cy);
	void SetFastBackWardState();
	void SortControl();
	void SetFastForwardState();
	void SetPauseState(BOOL bPause);
	void SetPlayState();
	void SetStopState();
	void Pause(BOOL bPause);
	void Stop();
	void Play();
	BOOL	BrowseFile(CString *strFileName);
	
	BOOL		m_bStartDraw;
	CPoint		m_StartPoint;
	CRect		m_rcDraw;
	CRect		m_rcDisplay;
	int			m_nSpeed;
	LONG		m_nDisplayType;
	CSeek *		m_pSeek;
	CDisplayRect* m_pDisplayRegion;
	BOOL		m_bFileRefCreated;
	DWORD		m_nHeadSize;
	BOOL		m_bFileEnd;
	DWORD		m_nMaxFileSize;
	BOOL		m_bStreamType;
	HANDLE		m_hEventKill;
	HANDLE		m_hEventInput;
	HANDLE		m_hThread;
	HANDLE		m_hStreamFile;
	LONG		m_nWidth;
	LONG		m_nHeight;
	BOOL		m_bPicQuality;
	DWORD		m_nTotalSecond;
	DWORD		m_nTotalMinute;
	DWORD		m_nTotalHour;
	DWORD		m_nTotalFrames;
	DWORD		m_nPreTime;
	int			m_nPrePlayPos;
	DWORD		m_nPlayButtonsWidth;
	BOOL		m_bInitialized;
	DWORD		m_nDlgTopSize;
	DWORD		m_nDlgEdge;
	DWORD		m_nMaxFileTime;
	BOOL		m_bSound;
	DWORD		m_bOpen;
	BOOL		m_bPause;
	CBitmap		m_Bmp;
	CBitmap		m_BlackBmp;
	CBitmap		m_OverlayBmp;
	CMenu *		m_pMainMenu;
	BOOL		m_bRepeatPlay;
	BOOL		m_bFastForwardPlay;
	WINDOWPLACEMENT m_OldWndpl;
	BOOL		m_bFullScreen;
	BOOL		m_bPaused;
	BOOL		m_bPlaying;
	CString		m_strPlayFileName;
	DWORD		m_dwPlaySliderMax;

	

// Dialog Data
	//{{AFX_DATA(CPlayerDlg)
	enum { IDD = IDD_PLAYER_DIALOG };
	CSliderCtrl	m_SliderB;
	CSliderCtrl	m_SliderS;
	CSliderCtrl	m_SliderH;
	CSliderCtrl	m_SliderC;
	CStatic	m_ShowFrame;
	CSliderCtrl	m_SoundSlider;
	CSliderCtrl	m_PlaySlider;
	CString	m_strPlayStateText;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlayerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hSoundStartIcon;
	HICON m_hSoundStopIcon;
	HICON m_hIcon;
	HICON m_hPlayEnableIcon;
	HICON m_hPlayDisableIcon;
	HICON m_hPauseEnableIcon;
	HICON m_hPauseDisableIcon;
	HICON m_hStopEnableIcon;
	HICON m_hStopDisableIcon;

	HICON m_hGotoStartDisableIcon;
	HICON m_hGotoEndDisableIcon;
	HICON m_hFastForwardDisableIcon;
	HICON m_hFastBackwardDisableIcon;
	HICON m_hGotoStartEnableIcon;
	HICON m_hGotoEndEnableIcon;
	HICON m_hFastForwardEnableIcon;
	HICON m_hFastBackwardEnableIcon;
	
	HICON m_hSoundOpenedIcon;
	HICON m_hSoundClosedIcon;
	afx_msg void DisplayOk(WPARAM wParam, LPARAM lParam);
	afx_msg void SeekOk(WPARAM wParam, LPARAM lParam);
	afx_msg void PlayMessage(WPARAM wParam, LPARAM lParam);
	afx_msg void EncChangeMessage(WPARAM wParam, LPARAM lParam);
	// Generated message map functions
	//{{AFX_MSG(CPlayerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileOpen();
	afx_msg void OnFileClose();
	afx_msg void OnPlay();
	afx_msg void OnPause();
	afx_msg void OnStop();
	afx_msg void OnGotoStart();
	afx_msg void OnFastBackward();
	afx_msg void OnFastForward();
	afx_msg void OnGotoEnd();
	afx_msg void OnDestroy();
	afx_msg void OnAppAbout();
	afx_msg void OnViewFullscreen();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSound();
	afx_msg void OnStep();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnCappic();
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnRepeat();
	afx_msg void OnQuality();
	afx_msg void OnViewZoom100();
	afx_msg void OnViewZoom200();
	afx_msg void OnViewZoom50();
	afx_msg void OnWindowPosChanged(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnStreamType();
	afx_msg void OnStepback();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnInfo();
	afx_msg void OnSeek();
	afx_msg void OnCutFile();
	afx_msg void OnThrow0();
	afx_msg void OnThrow1();
	afx_msg void OnThrow2();
	afx_msg void OnDisnormal();
	afx_msg void OnDisquarter();
	afx_msg void OnSetDisplay();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer1();
	afx_msg void OnTimer2();
	afx_msg void OnResetBuf();
	afx_msg void OnConvertToAVI();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYERDLG_H__BC7E7078_7E67_40B3_85A4_591E51BB1A4A__INCLUDED_)
