/*
 * File
 * 	h264dm.c
 * 	
 * Description:	
 * 	This is a loop test program for DVR card.
 * 	
 * Author:
 * 	write by wrh at 2003.4.18
 * 
 * Last update: 2005-1-19
 */

#include <stdio.h>
#include <stdlib.h>
#include <gdk/gdkx.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <SDL/SDL.h>


#include <sys/vfs.h>	//statfs()
#include <time.h>
#include <dirent.h> 	//opendir()
#include <unistd.h> 	//unlink(), getcwd()
#include <sys/stat.h>	//stat()
#include <string.h>
#include <fcntl.h>
#include <semaphore.h>
#include <errno.h>

#include "test.h"
#include "dvrcardApi.h"
#include "tmserverpu.h"

#define WRITE_FILE

#define BMPFILE

#define LOGO

//define MOTION_DEBUG

//#define YUVFILE
int qcif_flag[MAX_PORT];
int hcif_flag[MAX_PORT];
int cifqcif_flag[MAX_PORT];

static int totalcard, totalport;
RECT video_rect[MAX_PORT];
video_win v_win[MAX_PORT];
VideoStandard_t videostandard[MAX_PORT];
video_info v_info[MAX_PORT];
//add at 2002.4.10
GtkWidget *w_full_area;
video_win full_win;
SDL_Rect full_rect;

GdkColormap *camp;
GdkGC *gc1, *gc2; /* gc1 for title window, gc2 for video window */

GtkWidget *title;
GtkWidget *w_buttons[3];
char *button_str[3] = {" Start ", "  Stop ", "  Exit  "};
GtkWidget *w_image;
GtkWidget *w_record_flag;
GtkWidget *w_motion_detect_flag;
GtkWidget *w_I_frame;

GtkWidget *w_status[3];
char *status_str[3] = {"Data", "Time", "Free space"};

GtkWidget *w_info_scale[4];
char *info_str[4] = {"Brightness","Contrast","Saturation",  " Hue "}; 
GtkObject *w_adj[4];

//timer
int processtimer = 0;
time_t now;
struct tm *tm;
char timebuf[100];
char savepath[50] = "/home/wrh/testfile";

GTimer *count_timer = NULL;
gdouble elapse_time = 0;

/* add at 2002.4.1 */
int count[MAX_PORT];
int fixsize =  10 * 1024 * 1024;
struct stat statbuf;
char filename[MAX_PORT][40];
/* add at 2002 4.4 */
int old_count[MAX_PORT];
static int fullflag = 0;	/* space full flag */
static unsigned int limitsize = 0;
static int selectport = 0;	

/* frame infomations add at 2002.4.11 */
GtkWidget *w_audio_framerate;
GtkWidget *w_video_framerate;
GtkWidget *w_totalframe;
GtkWidget *w_channel;
GtkWidget *w_netusercount;

GtkWidget *w_net_transfer;
/*add for audio preview at 2002.5.14 */
GtkWidget *w_audio_preview;
int audiopreviewport = 0;

/*add at 2003.5.28, for start/stop preview*/
GtkWidget *w_preview;

/* add at 2004.8 for test that send string to client */
GtkWidget *w_stringtoclient;
 
int ChannelHandle[MAX_PORT];

int record_fd[MAX_PORT];
int cifqcif_fd[MAX_PORT];
int video_height[MAX_PORT];

//int captureflag[MAX_PORT];
char file_head[MAX_PORT][40];
char cifqciffile_head[MAX_PORT][40];
int record_flag[MAX_PORT];


/*add at 2002.4.27 */
struct statfs bbuf;
int looptimer = 0;
int timeconst = 60 * 5;	/* 5 minuts */
char starttime[100];

/* for motion detection */
int sensitivity = 1;
unsigned char motion_data[MAX_PORT][4 * 18];	
//unsigned short motion_data[MAX_PORT][(22) * (18)];
RECT motion_rect[MAX_PORT];
RECT motion_list[MAX_PORT];
int full_win_flag = 0;
static int clickflag = 1;	
static int clickport = -1;

static int net_flag = 0;
static int net_head_flag[MAX_PORT];
int head_size = 0;

//watch file dparaments  
int watchtimer;
unsigned long old_frames[MAX_PORT];
unsigned long current_frames[MAX_PORT];
unsigned long zero_count[MAX_PORT];


/* add for set logo by wrh at 2002.4.12 */
int logo_w, logo_h;
unsigned char *logoptr;
int flogoyuv;

unsigned short format1[] = {16,19,'O','f','f','i','c','e','\0'};
unsigned short format2[] = {8,3,_OSD_YEAR4,'-',_OSD_MONTH2,'-',_OSD_DAY,' ',_OSD_HOUR24,':',_OSD_MINUTE,':',_OSD_SECOND,'\0'};

/* yxq test at 2004.4.15*/
//unsigned short format2[] = {16,19,0xbcfa,0xc249,0xf1b9,'\0'};
//unsigned short format2[] = {16,19,0xe7ae,0xe1aa,0x73b7,0x4bac,0x50b6,0x64a5,'\0'};
//unsigned short format2[] = {16,19,0xa2b3,0xa3ce,0x6cdb,0x6ebd,'\0'};

//for bit rate watch
GtkWidget *w_set_bit_rate;
BitrateControlType_t brc = brCBR;

gdouble  bit_rate_time[MAX_PORT];
unsigned int bit_rate_size[MAX_PORT];
char set_bit_rate_str[MAX_PORT][20];
GtkWidget *w_bit_rate;

int win_width = 1024; 
static SDL_Surface      *pOverlayScreen;
SDL_Rect dstRect[MAX_PORT];

#define	WIN_W	800
#define	WIN_H	700
//static int	previewtimer = 0;


unsigned short stream_type = STREAM_TYPE_AVSYNC;

void my_exit();

void end_record(int port)
{	
	if(record_fd[port]){
		close(record_fd[port]);
		record_fd[port] = -1;
	}
	if(cifqcif_fd[port]){
		close(cifqcif_fd[port]);
		cifqcif_fd[port] = -1;
	}
}


//callback for net server
void message_callback(char *buf, int length)
{
	printf("Get a message from client: length = %d, message = %s\n",length, buf); 
}

int check_IP_callback(int channel, char *sIP)
{
	//printf("Check IP: channel = %d, IP= %s\n", channel, sIP);
	return 0;
}

int check_password_callback(char *username, int namelen, char *password, int passlen)
{
	//printf("Check password: username = %s, namelen = %d, password = %s, passname = %d\n", username, namelen, password, passlen);
	return 0;
}

void start_capture_callback(int port)	//for server start
{
	if((!record_flag[port]) && ( port < totalport)){//fixed at 2004.11.11
		g_timer_start(count_timer);
		StartVideoCapture(ChannelHandle[port]);
	}
}

void stop_capture_callback(int port)	//for server stop
{
	if((!record_flag[port]) && (port < totalport)){//fixed at 2004.11.11
		g_timer_stop(count_timer);
		StopVideoCapture(ChannelHandle[port]);
	}
}
//end callback for net server

void net_transfer_callback(GtkWidget *widget, gpointer data)
{
	int port;
	SERVER_VIDEOINFO videoinfo;
	
	if(GTK_TOGGLE_BUTTON(widget)->active)
	{//start net transfer
		for(port = 0; port < totalport; port++){
			MP4_ServerSetBufNum(port, 60);
		}

		MP4_ServerSetStart(start_capture_callback);
		MP4_ServerSetStop(stop_capture_callback);
		MP4_ServerSetMessage(message_callback);
		MP4_ServerSetNetPort(5050, 6050);
		videoinfo.m_channum = 16;//totalport;
	//printf("net_transfer_callback(): videoinfo.m_channum %d, totalport = %d\n", videoinfo.m_channum, totalport);
		if(MP4_ServerStart(&videoinfo) < 0){
			net_flag = 0;
			printf("Net start failed;\n");
		}
		else{	//fixed by wrh
			MP4_ServerCheckIP(check_IP_callback);
			MP4_ServerCheckPassword(check_password_callback);	
			net_flag = 1;
		}
	}
	else{//stop net transfer
		net_flag = 0;
		videoinfo.m_channum = 0;
		printf("call MP4_serverStop(), totalport = %d\n", totalport);
		MP4_ServerStop();
		memset(net_head_flag, 0, sizeof(net_head_flag));
	}
}

void preview_callback(GtkWidget *widget, gpointer data)
{
	int port;
	
	if(GTK_TOGGLE_BUTTON(widget)->active)
	{//start preview
		for(port = 0; port < totalport; port++){
			StartVideoPreview(ChannelHandle[port], pOverlayScreen, dstRect[port]);
		}
	}
	else//stop preview
	{
		if(full_win_flag){
			StopVideoPreview(ChannelHandle[clickport]);
			clickflag ^= 1;
		}
		else
			for(port = 0; port < totalport; port++)
				StopVideoPreview(ChannelHandle[port]);
	}

	full_win_flag = 0;
}

void set_bit_rate_callback(GtkWidget *widget)
{
	char *str;
	long max_bps;
	
	str = gtk_entry_get_text(GTK_ENTRY(w_set_bit_rate));
	strcpy(set_bit_rate_str[selectport], str);
	
	max_bps = atol(str);

	printf("selectport = %d, bps = %ld\n", selectport, max_bps);
	SetupBitrateControl(ChannelHandle[selectport], max_bps);
}

/* add at 2002.5.14 for audio preview */
void audio_preview_callback(GtkWidget *widget, gpointer data)
{
	int ret;
	ret = SetAudioPreview(ChannelHandle[audiopreviewport], GTK_TOGGLE_BUTTON(widget)->active);
	if(ret < 0)
		printf("Audio preview error.\n");
}

/* record operation*/
void record_callback(GtkWidget *widget, gpointer data)
{
	int port, retval;
	if(GTK_TOGGLE_BUTTON(w_record_flag)->active){ // start capture 
		for(port = 0; port < totalport; port++)
		{
#ifdef WRITE_FILE 
			sprintf(filename[port], "%s/test%02d%d.mp4", savepath, port, count[port]); 
			if((record_fd[port] = open(filename[port], O_WRONLY | O_CREAT, 0777)) < 0)
				perror(">>>open");
			else
			{
				ftruncate(record_fd[port], 0);
				//captureflag[port] = 1;
			}
			if(cifqcif_flag[port])
			{
				sprintf(filename[port], "%s/test%02d%d_1.mp4", savepath, port, count[port]); 
				if((cifqcif_fd[port] = open(filename[port], O_WRONLY | O_CREAT, 0777)) < 0)
					perror(">>>open the subchannel");
				else
				{
					ftruncate(cifqcif_fd[port], 0);
				}
			}
					
			zero_count[port] = 0;
			if(net_flag){
				write(record_fd[port], file_head[port], 40);
				if(cifqcif_flag[port])
					write(cifqcif_fd[port], cifqciffile_head[port], 40);
				record_flag[port] = 1;
			}
			else{
				g_timer_start(count_timer);
				retval = StartVideoCapture(ChannelHandle[port]);
				if(retval < 0)
				{
					record_flag[port] = 0;
					printf("StartVideoCapture failed. \n");
				}
				record_flag[port] = 1;
			}
			
		}
#endif
	}
	else	//stop capture
	{
		for(port = 0; port < totalport; port++){
			end_record(port);
			record_flag[port] = 0;
			if(!net_flag){	
				g_timer_stop(count_timer);
				if(StopVideoCapture(ChannelHandle[port]) < 0)
					printf("record_callbacl: StopvideoCapture(port %d) failed\n", port);
			}
			current_frames[port] = 0;
			old_frames[port] = 0;
		}
		memset(count, 0, sizeof(count));
	}
}

void stringtoclient_callback(GtkWidget *widget, gpointer data)
{
	int	port;
	char	messagebuf[256];
	/* test the string to client */
	for(port = 0; port < 20; port++)
	{
		sprintf(messagebuf, "server message to client, no.%d!\n", port);
		MP4_ServerStringToClient("192.0.0.128", messagebuf, strlen(messagebuf));
		fprintf(stderr,"<demo_info> have send the len %d message to client!\n", strlen(messagebuf));
	}
}

void motion_detect_callback(GtkWidget *widget, gpointer data)
{
	int port;
	if(GTK_TOGGLE_BUTTON(w_motion_detect_flag)->active){ // start motion_detect 
		for(port = 0; port < totalport; port++)
       			StartMotionDetection(ChannelHandle[port]);
	}
	else{//stop motion detect
		for(port = 0; port < totalport; port++){
        		StopMotionDetection(ChannelHandle[port]);
		}
		memset(motion_data, 0, sizeof(motion_data));
	}
}


/* for motion detect */
void motion_detect(int channel)
{
	int x, y;
	float ratioX, ratioY;
	unsigned int *pBuf = (unsigned int *)motion_data[channel];

	if((full_win_flag) && (channel == clickport)){
		ratioX = (float)full_win.w / (float)704;
		ratioY = (float)full_win.h /(float)video_height[channel];
		pBuf = (unsigned int *)motion_data[channel];
#ifdef MOTION_DEBUG
		printf("full_win(port %d): ratioX = %f, ratioY = %f,\n",channel, ratioX, ratioY);
#endif
		for(y = 0; y < 18; y ++){
			unsigned int val = pBuf[y];
		//	printf("colum %d, val = 0x%08lx\n", y, val);
			for(x = 0; x < 22; x++){
				if(val & (1 << x)){
			//		printf(">>>>>> motion at (%d, %d), val = 0x%lx <<<<<\n", x,y, val);
					gdk_draw_rectangle(w_full_area->window, gc2, TRUE, 
							full_win.x + x * ratioX * 32, 
							full_win.y + y * ratioY * 32, 
							ratioX * 32, 
							ratioY * 32);
				}
			}
		}
		return;
	}
	else{
		ratioX = (float)v_win[channel].w /(float)704;
		ratioY = (float)v_win[channel].h /(float)video_height[channel];
#ifdef MOTION_DEBUG
		if(channel == 2)
			printf("port %02d: ratioX= %08f, ratioY = %08f, RectLeft = %03d, RectTop = %03d\n",channel, ratioX,ratioY,motion_list[channel].RectLeft,  motion_list[channel].RectTop );
#endif
		for(y = 0; y < 18; y++){
			unsigned int val = pBuf[y];
			for(x = 0; x< 22; x ++){
				if(val & (1 << x)){
					gdk_draw_rectangle(w_full_area->window, gc2, TRUE, 
							motion_list[channel].RectLeft +  x * ratioX * 32 , 
							motion_list[channel].RectTop + y * ratioY * 32, 
							ratioX * 32,
							ratioY * 32);
				}
			}
		}
	}//else
}


void StreamRead_callback(int channel, char *databuf, int frametype, int framelength, int framenum)
{
	int subType;
/*
	if((channel == 0) && (frametype != PktAudioFrames))
		printf("channel=%d, frametype=0x%x, framelength=%6d, framenum=%4d\n", channel,frametype,framelength,framenum);
*/
	
	switch(frametype)
	{
		case PktSysHeader:
		case PktIFrames:			
		case PktPFrames:
		case PktBBPFrames:
		case PktAudioFrames:
		case PktSFrames:
		{
			if(cifqcif_flag[channel] == 0)
			{
				if(frametype == PktSysHeader){
					memcpy(file_head[channel], databuf, framelength);
					head_size = framelength;
				}
				/* modify at 2002.5.10 by wrh */
				//if(captureflag[channel] && capture_fd[channel]){
				if(record_flag[channel] && record_fd[channel]){
					write(record_fd[channel], databuf, framelength);
				}
				bit_rate_size[channel] += framelength;
							
				if(net_flag){
				//fprintf(stderr,"StreamRead_callback(): net_flag is 1, net_head_flag[%d] = %d, frametype = %d\n",channel, net_head_flag[channel], frametype); 
					if(net_head_flag[channel] == 0){
						if(frametype != PktSysHeader){
							//fprintf(stderr,"frametype != PktSyaHeader\n");
							MP4_ServerWriteData(channel,file_head[channel], head_size, PktSysHeader, 0);
						}
						else 
							MP4_ServerWriteData(channel,(char*)databuf,framelength,frametype, 0);
						net_head_flag[channel] = 1;
					}
					else
						MP4_ServerWriteData(channel,(char*)databuf,framelength,frametype, 0);
				}
			}
			else
			{
				subType = GetSubChannelStreamType(databuf, frametype);
				
				if(subType == 1){
					memcpy(file_head[channel], databuf, framelength);
					head_size = framelength;
				}
				if(subType == 2){
					memcpy(cifqciffile_head[channel], databuf, framelength);
					head_size = framelength;
				}
				if(record_flag[channel] && record_fd[channel]&&((subType == 1)||(subType == 3)||(subType == 5))){
					write(record_fd[channel], databuf, framelength);
				}
				if(record_flag[channel] && record_fd[channel] && ((subType == 2)||(subType == 4)||(subType == 5))){
					write(cifqcif_fd[channel], databuf, framelength);
				}
				bit_rate_size[channel] += framelength;
							
				if((net_flag)&&((subType == 2)||(subType == 4)||(subType ==5))){
					if(net_head_flag[channel] == 0){
						if(frametype != PktSysHeader){
							MP4_ServerWriteData(channel,cifqciffile_head[channel], head_size, PktSysHeader, 0);
						}
						else 
							MP4_ServerWriteData(channel,(char*)databuf,framelength,frametype, 0);
						net_head_flag[channel] = 1;
					}
					else
						MP4_ServerWriteData(channel,(char*)databuf,framelength,frametype, 0);
				}
			}
			break;
		}
		case PktMotionDetection:
		{
			int length;
#ifdef MOTION_DEBUG
			if(channel == 2)
				printf("PktMotionDetection: channel = %d\n", channel);
#endif
			length = framelength;
			memcpy(motion_data[channel], databuf + sizeof(MOTION_DATA_HEADER),  length);
			if(GTK_TOGGLE_BUTTON(w_motion_detect_flag)->active) // motion_detect started
				motion_detect(channel);
			break;
		}
		default:
			break;
	}
}

void my_exit()
{
	int port;

	printf("End ......\n");
	MP4_ServerStop();	
	
	if(watchtimer){
		gtk_timeout_remove(watchtimer);
		watchtimer = 0;
	}
	if(processtimer){
		gtk_timeout_remove(processtimer);
		processtimer = 0;
	}
	if(looptimer){
		gtk_timeout_remove(looptimer);
		looptimer = 0;
	}
	if(count_timer){
		g_timer_destroy(count_timer);
		count_timer = NULL;
	}
	if(logoptr)
		free(logoptr);
		
	
	if(GTK_TOGGLE_BUTTON(w_audio_preview)->active){
		SetAudioPreview(ChannelHandle[audiopreviewport], 0); /*  port audio preview */
	}
	
	
	if(GTK_TOGGLE_BUTTON(w_preview)->active){
		if(full_win_flag){
			if(StopVideoPreview(ChannelHandle[clickport]) < 0)
				printf("StopVideopreview(port %d) failed, error 0x%x\n", clickport, GetLastErrorNum());
		}
		else{
			for(port = 0; port < totalport; port++)
			{
				if(StopVideoPreview(ChannelHandle[port]) < 0)
					printf("StopVideopreview(port %d) failed, error 0x%x\n", port, GetLastErrorNum());
			}
		}
	}

	for(port = 0; port < totalport; port++)
	{
	        StopMotionDetection(ChannelHandle[port]);
		end_record(port);
		if((record_flag[port]) && (StopVideoCapture(ChannelHandle[port]) < 0)){
			printf("StopVideoCapture(port %d) failed, error 0x%x\n", port, GetLastErrorNum());
			record_flag[port] = 0;
		}

		ChannelClose(ChannelHandle[port]);
	}

	memset(motion_data, 0, sizeof(motion_data));
	
	DeInitDSPs();

	gdk_flush();	
	SDL_Quit();/* yxq add at 2004.8.27*/
	gtk_main_quit();
}


int reset_dsp(int port)
{
	STREAM_READ_CALLBACK pStreamRead;
	pStreamRead = (STREAM_READ_CALLBACK)StreamRead_callback;
	
	ResetDSP(port);
	old_frames[port] = 0;
	current_frames[port] = 0;
	
	ChannelHandle[port] = ChannelOpen(port, pStreamRead);
	
	SetDefaultQuant(ChannelHandle[port],12,12,17);
	GetVideoPara(ChannelHandle[port],
	       &videostandard[port],	
		&v_info[port].Brightness, &v_info[port].Contrast, &v_info[port].Saturation, &v_info[port].Hue);
	SetOsdDisplayMode(ChannelHandle[port], 0xff, 1, 0x0000, format1, format2);
	SetOsd(ChannelHandle[port], 1);
#ifdef LOGO
	SetLogoDisplayMode(ChannelHandle[port], 0x0, 0x0, 0x0, 1, 0x2005);
 	if(videostandard[port] == StandardNTSC)	
		SetLogo(ChannelHandle[port], 576, 448, logo_w, logo_h, logoptr);
        else
	       SetLogo(ChannelHandle[port], 576, 544, logo_w, logo_h, logoptr);
#endif		
	g_timer_reset(count_timer);
	
	if(StartVideoPreview(ChannelHandle[port], pOverlayScreen, dstRect[port]) <0)
		printf("restart preview failed, error code = 0x%x\n", GetLastErrorNum());
	
	if(StartVideoCapture(ChannelHandle[port]) < 0){
		printf("restart capture failed, error code = 0x%x\n", GetLastErrorNum());
		return -1;
	}
	return 0;
}
 
//watch capture file, if no more data geted, then reset DSP
int process_watchtime_loop(gpointer data)
{
	int port;
	FRAMES_STATISTICS frame_statistics;

	
	for(port = 0; port < totalport; port++)
	{
		if((record_flag[port] == 0) && (net_flag == 0))
			continue;
		//for bit rate watch
		bit_rate_time[port] = g_timer_elapsed(count_timer, NULL);
		bit_rate_size[port] = 0;
	       	
		//get current frames
		GetFramesStatistics(ChannelHandle[port], &frame_statistics); 
		current_frames[port] = frame_statistics.VideoFrames; 
		
		if(old_frames[port] != current_frames[port]){
			old_frames[port] = current_frames[port];
			zero_count[port] = 0;
			continue;
		}
		else {
			zero_count[port] ++;
			if(zero_count[port] < 3)
				continue;
		}
			
		if(reset_dsp(port) == 0)//reset DSP success
		{
			int retval;
			end_record(port);
			count[port]++;
			sprintf(filename[port], "%s/test%02d%d.mp4", savepath, port, count[port]); 
			if((retval = open(filename[port], O_WRONLY | O_CREAT |O_TRUNC, S_IRWXU|S_IRWXG|S_IRWXO)) < 0)
				perror(">>> open");
			else{ 
					ftruncate(retval, 0);
					write(retval, file_head[port], 40);
					record_fd[port] = retval;
			}
			if(cifqcif_flag[port])
			{
				sprintf(filename[port], "%s/test%02d%d_1.mp4", savepath, port, count[port]); 
				if((retval = open(filename[port], O_WRONLY | O_CREAT |O_TRUNC, S_IRWXU|S_IRWXG|S_IRWXO)) < 0)
					perror(">>> open");
				else{ 
					ftruncate(retval, 0);
					write(retval, cifqciffile_head[port], 40);
					cifqcif_fd[port] = retval;
				}
			}
		}

	}
	return TRUE;	//if return 0, will never call this func.
}

int process_time_loop(gpointer data)
{
	int port;
		
	/* If no enough space, reset count*/
	if(fullflag)
	{
		for(port = 0; port < totalport; port++)
		{
			if(old_count[port] < count[port])
			{
				memcpy(old_count, count, sizeof(count));
				memset(count, -1, sizeof(count));
				break;
			}
		}
	}
	
 	else	
	{
		if((bbuf.f_bavail * (bbuf.f_bsize/1024)) <= limitsize) /* count in 1KB */
		{
			printf("No enough space.avialable blocks = %ld\n", bbuf.f_bavail);
			memcpy(old_count, count, sizeof(count));
			
			memset(count, -1, sizeof(count));
			fullflag = 1;
		}
	}
	
	/*add at 2002.4.1 */
	for(port = 0; port < totalport; port++)
	{
		int retval;
		
		if(record_flag[port] == 0)
			continue;
		
		end_record(port);
		count[port] ++;
			
#ifdef WRITE_FILE
		sprintf(filename[port], "%s/test%02d%d.mp4", savepath, port, count[port]); /* modify at 2002.4.1 */
		if((retval = open(filename[port], O_WRONLY | O_CREAT |O_TRUNC, S_IRWXU|S_IRWXG|S_IRWXO)) < 0)
			perror(">>> open");
		else{ 
			ftruncate(retval, 0);
			write(retval, file_head[port], 40);
			record_fd[port] = retval;
		}
		if(cifqcif_flag[port])
		{
			sprintf(filename[port], "%s/test%02d%d_1.mp4", savepath, port, count[port]); /* modify at 2002.4.1 */
			if((retval = open(filename[port], O_WRONLY | O_CREAT |O_TRUNC, S_IRWXU|S_IRWXG|S_IRWXO)) < 0)
				perror(">>> open");
			else{ 
				ftruncate(retval, 0);
				write(retval, cifqciffile_head[port], 40);
				cifqcif_fd[port] = retval;
			}
		}
#endif			
			
	}
	
	return TRUE;	//if return 0, will never call this func.
}

int process_time(gpointer data)
{
/*
	time_t now;
	struct tm *tm;
	*/
	char buf[100];
	char tmp[] = "%";
	//struct statfs bbuf;
	int freespace;
	static int totalframe;
	float audioframerate,videoframerate;
	FRAMES_STATISTICS frame_statistics;
	int usercount;
	int i;
	int bit_rate,tmptime;
	static int timecount = 0;	
	
	
	//printf("%ld\n", SDL_GetTicks());
	
	now = time(NULL);
	tm = localtime(&now);
	strftime(timebuf, sizeof(timebuf), "%Y-%m-%d", tm);
	gtk_text_backward_delete(GTK_TEXT(w_status[0]), strlen(timebuf));
	gtk_text_insert(GTK_TEXT(w_status[0]), NULL, NULL, NULL, timebuf, -1);
	strftime(timebuf, sizeof(timebuf), "%T", tm);
	gtk_text_backward_delete(GTK_TEXT(w_status[1]), strlen(timebuf));
	gtk_text_insert(GTK_TEXT(w_status[1]), NULL, NULL, NULL, timebuf, -1);

	if(statfs(savepath, &bbuf) < 0){
		printf("statsfs() faied, error: %d\n",  errno);
		//printf("savepath = %s, bbuf,f_bavail = %d, bbuf.f_blocks = %d\n", savepath, bbuf.f_bavail, bbuf.f_blocks);
	}
	else{
		freespace = (100*bbuf.f_bavail)/bbuf.f_blocks;
		sprintf(buf,"%3d%s", freespace, tmp);
	}

	//printf("total block = %d, availble block = %d, block size = %d\n", bbuf.f_blocks, bbuf.f_bavail, bbuf.f_bsize);
	gtk_text_backward_delete(GTK_TEXT(w_status[2]), strlen(buf));
	gtk_text_insert(GTK_TEXT(w_status[2]), NULL, NULL, NULL, buf, -1);
	sprintf(buf, "%9d", selectport);
	gtk_text_backward_delete(GTK_TEXT(w_channel), strlen(buf));
	gtk_text_insert(GTK_TEXT(w_channel), NULL, NULL, NULL, buf, -1);

	
	/* frame information */
	elapse_time = g_timer_elapsed(count_timer,NULL);
	GetFramesStatistics(ChannelHandle[selectport], &frame_statistics); 
	audioframerate = frame_statistics.AudioFrames/elapse_time;
	sprintf(buf, "%8.1f", audioframerate);
	gtk_text_backward_delete(GTK_TEXT(w_audio_framerate), strlen(buf));
	gtk_text_insert(GTK_TEXT(w_audio_framerate), NULL, NULL, NULL, buf, -1);
	videoframerate = frame_statistics.VideoFrames/elapse_time;
	sprintf(buf, "%8.1f", videoframerate);
	gtk_text_backward_delete(GTK_TEXT(w_video_framerate), strlen(buf));
	gtk_text_insert(GTK_TEXT(w_video_framerate), NULL, NULL, NULL, buf, -1);
	
	//bit rate
	tmptime = elapse_time - bit_rate_time[selectport];
	if(tmptime>0){
		bit_rate = (bit_rate_size[selectport] * 8)/(elapse_time - bit_rate_time[selectport]);
		sprintf(buf, "%10d", bit_rate);
		gtk_text_backward_delete(GTK_TEXT(w_bit_rate), strlen(buf));
		gtk_text_insert(GTK_TEXT(w_bit_rate), NULL, NULL, NULL, buf, -1);
	}

	totalframe = frame_statistics.VideoFrames + frame_statistics.AudioFrames;
	sprintf(buf, "%10d", totalframe);
	gtk_text_backward_delete(GTK_TEXT(w_totalframe), strlen(buf));
	gtk_text_insert(GTK_TEXT(w_totalframe), NULL, NULL, NULL, buf, -1);

	usercount = MP4_ServerGetState();
	if(usercount>0)
	{
		sprintf(buf,"%7d", usercount);
		gtk_text_backward_delete(GTK_TEXT(w_netusercount), strlen(buf));
		gtk_text_insert(GTK_TEXT(w_netusercount), NULL, NULL, NULL, buf, -1);
	}
	else{
		sprintf(buf,"       0");
		gtk_text_backward_delete(GTK_TEXT(w_netusercount), strlen(buf));
		gtk_text_insert(GTK_TEXT(w_netusercount), NULL, NULL, NULL, buf, -1);
	}

	return TRUE;	//if return 0, will never call this func.
}
	
	
void process_buttons(GtkWidget *widget, gpointer data)
{
	int i, port;
	//char filename[40];
	int retval = 0;
		
	i = GPOINTER_TO_INT(data);

	switch(i){
		case 2:	//exit
			my_exit();
			break;
		case 3:/* get image */
			{
				static int image_count = 0;
				unsigned char imagebuf[704 * 576 * 2];
				int size; //;= 384 * 288 *2;
				char filename[100];
#ifdef YUVFILE
				int fid;
#endif

				for(port = 0; port < totalport; port++){
					retval = GetOriginalImage(ChannelHandle[port], imagebuf, &size);
#ifdef BMPFILE
					sprintf(filename, "cap%d%d.bmp", port, image_count);
					if(retval < 0){
						printf("GetOriginalImage return %d\n", retval);
						continue;
					}
					else
					{
						printf("GetOriginalImage OK size = %d\n", size);
						
						if(size == 704 * 576 * 2)//PAL 
							SaveYUVToBmpFile(filename, imagebuf, 704, 576);
						if(size == 704 * 480 * 2)//NTSC
							SaveYUVToBmpFile(filename, imagebuf, 704, 480);
					}
#endif
#ifdef YUVFILE
					sprintf(filename, "cap%d.yuv", port);
					fid = open(filename, O_WRONLY | O_CREAT | O_TRUNC , 0777);
					if(fid < 0)
					{
						perror("get image:");
						break;
					}
					size = 0;
					retval = GetOriginalImage(ChannelHandle[port], imagebuf, &size);
					if(retval < 0){
						printf("GetOriginalImage return %d\n", retval);
						continue;
					}
							
					else
					{
						printf("   size = %d\n", size);
						write(fid, imagebuf, size);
					}
					close(fid);
#endif
				}
				image_count ++;
				break;
			}
		case 4://capture I frame
			for(port = 0; port < totalport; port++)
			{
				CaptureIFrame(ChannelHandle[port]);
				break;
			}	
		default:
			break;
	}	
			
}

//video info changed
void ch_bscale(GtkAdjustment *adjust, gpointer   data)
{
	int i, port;
	i = GPOINTER_TO_INT(data);
	switch(i){
		case 0:
			v_info[0].Brightness = (gint)adjust->value;
			break;
		case 1:
			v_info[0].Contrast = (gint)adjust->value;
			break;
		case 2:
			v_info[0].Saturation = (gint)adjust->value;
			break;
		case 3:
			v_info[0].Hue = (gint)adjust->value;
			break;
		default:
			break;
	}
	
	for(port = 0; port < totalport; port++)
	{
		SetVideoPara(ChannelHandle[port], 
			v_info[0].Brightness, v_info[0].Contrast, v_info[0].Saturation, v_info[0].Hue); 
	
	}
}

/* add 2002.4.10 */
int PtInRect(SDL_Rect rect, int x, int y)
{
	if((x > (full_win.x + rect.x)) && (x < (full_win.x + rect.x + rect.w)) && (y > (full_win.y + rect.y)) && (y < (full_win.y + rect.y + rect.h))) 
		return 1; /* point in rect */
	return 0;
}


int GetPort()
{
	int port = -1;
	int x, y, i;
	
	gdk_window_get_pointer(w_full_area->window, &x, &y, NULL);
	x += full_win.x;
	y += full_win.y;

	for(i = 0; i< totalport; i++)	
	{
		if(PtInRect(dstRect[i], x, y))
		{
			port = i;
			break;
		}
	}
	return port;
}

int click2(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	int port, i;
	
	if(!GTK_TOGGLE_BUTTON(w_preview)->active)
		return 0;
	
	port = GetPort();
	if(port >= 0)
	{
		selectport = port;
		if(strlen(set_bit_rate_str[selectport]) == 0)
			gtk_entry_set_text(GTK_ENTRY(w_set_bit_rate), "0");
		else
			gtk_entry_set_text(GTK_ENTRY(w_set_bit_rate), set_bit_rate_str[selectport]);
	}

	/* button press twice */	
	if(event->type  != GDK_2BUTTON_PRESS/*5*/)
	{
		if(port < 0)
			return -1;
		if(GTK_TOGGLE_BUTTON(w_audio_preview)->active)
		{
			/* add at 2002.5.14 for audio preview */
			SetAudioPreview(ChannelHandle[audiopreviewport], 0); /* stop old port audio preview */
			audiopreviewport = port;
			SetAudioPreview(ChannelHandle[audiopreviewport], 1); /* start new port audio preview */
		}
		return (TRUE);
	}
										
	if(clickflag)
	{
		if(port < 0)
			return TRUE;
		for(i = 0; i< totalport; i++)	
		{
			if(StopVideoPreview(ChannelHandle[i]) < 0)
				printf("StoptVideoPreview(channel %d) failed\n", i);
		}
		clickport = port;
		if(StartVideoPreview(ChannelHandle[port], pOverlayScreen, full_rect) < 0)
			printf("start video preview(port %d) failed\n", port);
		full_win_flag = 1;
	}
	else 
	{
		//GdkRectangle GdkRect;
		if(StopVideoPreview(ChannelHandle[clickport]))
		/* generate expose event */
		gdk_window_hide(w_full_area->window);
		usleep(1000);
		gdk_window_show(w_full_area->window);
		
		for(i = 0; i < totalport; i++){
			gdk_window_clear(w_full_area->window);
			if(StartVideoPreview(ChannelHandle[i], pOverlayScreen, dstRect[i]) < 0)
				printf("start video preview(port %d) failed\n", i);
		}
		full_win_flag = 0;
	}
	clickflag ^= 1;

	return 0;
}

gint expose_ev( GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   data )
{
	char *str1 = "Demo - loop test for DVR card";
	GdkFont *font = NULL;
	GdkColor color;
	char title_str[160];
	char tmpstr[] = " ";
	

	sprintf(title_str, "%s %20s Start Time: %s", str1, tmpstr, starttime);
		
	camp = gdk_colormap_get_system();
	gc1 = gdk_gc_new(title->window);	//get GC
	
	//title expose
	if(widget->window == title->window)
	{
		//set title background
		color.red = 0;
		color.green = 0;
		color.blue = 0xffff;
		if(!gdk_color_alloc(camp, &color)){
			g_error("Cannot allocate color\n");
		}
		gdk_window_set_background(widget->window, &color);

		//set foreground
		
		color.red = 0xffff;
		color.green = 0xffff;
		color.blue = 0xffff;
		if(!gdk_color_alloc(camp, &color)){
			g_error("Cannot allocate color\n");
		}
		gdk_gc_set_foreground(gc1, &color);
		gdk_window_clear(widget->window);

		//font = gdk_fontset_load("7x14,hanzigb16fs");
		font = gdk_fontset_load("-*-*-*-*-normal--15-*-*-*-*-*-*");
		if(font != NULL){
			gdk_draw_text(widget->window, font, gc1, 10, 20, title_str, strlen(title_str));
			gdk_font_unref(font);
		}
		
		return(TRUE);
	}

	//video_area expose
	//allocte color
	gc2 = gdk_gc_new(w_full_area->window);	//get GC
	if(gdk_color_parse("black", &color))
	{
		if( !gdk_colormap_alloc_color(camp, &color,FALSE, TRUE)){
			g_error("Cannot allocate color\n");
		}
	}
		
	gdk_window_set_background(widget->window, &color);	//set background color	
	
	/* set foreground to sign motion block */
	color.red = 0;
	color.green = 0xffff;
	color.blue = 0;
	if(!gdk_color_alloc(camp, &color)){
		g_error("Cannot allocate color\n");
	}
	gdk_gc_set_foreground(gc2, &color);
	gdk_window_clear(widget->window);
		
	return(TRUE);
}

int main(int argc, char *argv[])
{
	GtkWidget *window;
	GtkWidget *frame, *main_box, *hbox, *hbox1, *vbox1, *vbox2, *hbox2;
	GtkWidget *label;
	GdkVisual *visual;
	int height; /* yxq modified at 2004.2.23*/
	int i, j;
	char	SDL_windowhack[32]; /* yxq add at 2004.8.25*/

	/* for callback function, add at 2002.4.24 */
	STREAM_READ_CALLBACK pStreamRead;
	pStreamRead = (STREAM_READ_CALLBACK)StreamRead_callback;

	/* init display */
	gtk_set_locale();
	gtk_init(&argc, &argv);		
	camp = gdk_colormap_get_system();

	//get display size
	win_width = DisplayWidth(gdk_display, gdk_screen);
	height = DisplayHeight(gdk_display, gdk_screen); 
	
	visual = gdk_visual_get_system();

	/* get current directory */
	//getcwd(savepath, 50);
	
	//create window
	//window = gtk_window_new(GTK_WINDOW_POPUP);
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_signal_connect(GTK_OBJECT(window),"delete_event",
		GTK_SIGNAL_FUNC(my_exit),NULL);
	gtk_signal_connect(GTK_OBJECT(window),"destroy",
		GTK_SIGNAL_FUNC(my_exit),NULL);

	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	gtk_widget_set_usize(window, win_width, height);
	
	frame = gtk_frame_new(NULL);
	gtk_container_add(GTK_CONTAINER(window), frame);

	main_box = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame), main_box);
	
	hbox = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 0);
	gtk_box_pack_start(GTK_BOX (main_box), hbox, FALSE, /*TRUE*/FALSE, 0);

	/******* title window *******/
	title = gtk_drawing_area_new();
	gtk_widget_set_usize(title, win_width, 30);
			
	gtk_widget_set_events(title, GDK_EXPOSURE_MASK);
	gtk_signal_connect(GTK_OBJECT (title), "expose_event",
			GTK_SIGNAL_FUNC(expose_ev), NULL);
	gtk_box_pack_start(GTK_BOX(hbox), title, FALSE, FALSE, 0);
	/************* end title window ***********/

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(main_box), hbox, FALSE, TRUE, 0);

	/***************** channel window **********************/
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start(GTK_BOX(hbox), frame, FALSE, FALSE, 0);
/*
	yxq modified at 2004.8.27
	vbox1 = gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(frame), vbox1);
*/

	/* modify at 2002.4.10 */
	full_win.w = WIN_W;
	full_win.h = WIN_H;
	w_full_area = gtk_drawing_area_new();
	gtk_widget_set_usize(w_full_area, full_win.w, full_win.h);
	gtk_widget_set_events(w_full_area, GDK_EXPOSURE_MASK |
				GDK_BUTTON_PRESS_MASK); 
	gtk_signal_connect(GTK_OBJECT(w_full_area), "expose_event",
				GTK_SIGNAL_FUNC(expose_ev), NULL);
	gtk_signal_connect(GTK_OBJECT(w_full_area), "button_press_event",
				GTK_SIGNAL_FUNC(click2), GINT_TO_POINTER(-1));
	//gtk_box_pack_start(GTK_BOX(vbox1), w_full_area, FALSE, FALSE, 0);
	/* yxq modified at 2004.8.27*/
	gtk_container_add(GTK_CONTAINER(frame), w_full_area);
	/***************** end channel window **********************/
	
	
	/****************** opearate window *********************/
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start(GTK_BOX(hbox), frame, TRUE/*FALSE*/, TRUE/*FALSE*/, 0);
	
	vbox1 = gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(frame), vbox1);
	
	//status information	
	frame = gtk_frame_new("Status Information");
	gtk_box_pack_start(GTK_BOX (vbox1), frame, TRUE, FALSE, 0);
	
	vbox2 = gtk_vbox_new(FALSE,0);
	gtk_container_add(GTK_CONTAINER(frame), vbox2);

	for(i = 0; i < 3; i++)
	{
		hbox2 = gtk_hbox_new(FALSE, 0);
		gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 5);
		label = gtk_label_new(status_str[i]);
		gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 5);
		w_status[i] = gtk_text_new(NULL, NULL);
		gtk_widget_set_usize(w_status[i], 100,25);
		if(i ==2)
			gtk_widget_set_usize(w_status[i], 60,25);
		gtk_text_set_editable(GTK_TEXT(w_status[i]), FALSE);
		gtk_box_pack_start(GTK_BOX(hbox2), w_status[i], FALSE, FALSE,0);
				
	}

	/**	
	//display ports
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start(GTK_BOX (vbox1), frame, TRUE, FALSE, 0);

	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox2), 4);
	gtk_container_add(GTK_CONTAINER(frame), vbox2);
*/
	/* frame information */
	frame = gtk_frame_new("Channel Info");
	gtk_box_pack_start(GTK_BOX (vbox1), frame, /*FALSE*/TRUE, FALSE, 0);
	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame), vbox2);
	
 	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox2, TRUE, FALSE, 2);
	label = gtk_label_new("Channel");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 2);
	w_channel = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(w_channel, 95, 24);
	gtk_box_pack_start(GTK_BOX(hbox2), w_channel, FALSE, FALSE, 0);
 	
 	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox2, TRUE, FALSE, 2);
	label = gtk_label_new("a_frame rate");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 2);
	w_audio_framerate = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(w_audio_framerate, 95, 24);
	gtk_box_pack_start(GTK_BOX(hbox2), w_audio_framerate, FALSE, FALSE, 0);
 	
 	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox2, TRUE, FALSE, 2);
	label = gtk_label_new("v_frame rate");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 2);
	w_video_framerate = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(w_video_framerate, 95, 24);
	gtk_box_pack_start(GTK_BOX(hbox2), w_video_framerate, FALSE, FALSE, 0);
 	
 	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox2, TRUE, FALSE, 2);
	label = gtk_label_new("Total frame");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 2);
	w_totalframe = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(w_totalframe, 95, 24);
	gtk_box_pack_start(GTK_BOX(hbox2), w_totalframe, FALSE, FALSE, 0);
 	
 	//get bit rate
	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox2, TRUE, FALSE, 2);
	label = gtk_label_new("BitRate(bps)");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 2);
	w_bit_rate = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(w_bit_rate, 95, 24);
	gtk_box_pack_start(GTK_BOX(hbox2), w_bit_rate, FALSE, FALSE, 0);
 	
	//set bit_rate(bps)
	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox2, TRUE, FALSE, 0);
	label = gtk_label_new("SetBitRate(bps)");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 0);
	w_set_bit_rate = gtk_entry_new_with_max_length(10);
	gtk_widget_set_usize(w_set_bit_rate, 95, 24);
	gtk_entry_set_text(GTK_ENTRY(w_set_bit_rate),"0");
	gtk_box_pack_start(GTK_BOX(hbox2), w_set_bit_rate, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_set_bit_rate),"activate",
			GTK_SIGNAL_FUNC(set_bit_rate_callback), NULL);

	hbox2 = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox1), hbox2, TRUE, FALSE, 2);
	label = gtk_label_new("Net User Count");
	gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, FALSE, 2);
	w_netusercount = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(w_netusercount, 95, 24);
	gtk_box_pack_start(GTK_BOX(hbox2), w_netusercount, FALSE, FALSE, 0);

	/******* set video info ******/
	frame = gtk_frame_new("Video Info");
	gtk_box_pack_start(GTK_BOX (vbox1), frame, /*FALSE*/TRUE, FALSE, 0);

	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox1), 5);
	gtk_container_add(GTK_CONTAINER(frame), vbox2);
		
	for(i = 0; i < 4; i++){
		hbox1 = gtk_hbox_new(FALSE, 0);
		gtk_container_set_border_width(GTK_CONTAINER(hbox1), 0);
		gtk_box_pack_start(GTK_BOX (vbox2), hbox1, TRUE/*FALSE*/, /*TRUE*/FALSE, 0);
		
		label = gtk_label_new(info_str[i]);
		//gtk_widget_set_usize(GTK_WIDGET(label), 60, 20);
		gtk_box_pack_start(GTK_BOX (hbox1), label, TRUE/*FALSE*/, /*TRUE*/FALSE, 0);
		if(i ==0)
			w_adj[i] = gtk_adjustment_new(v_info[0].Brightness, 1, 256, 1, 1, 0);
		if(i ==1)
			w_adj[i] = gtk_adjustment_new(v_info[0].Contrast, 1, 128, 1, 1, 0);
		if(i ==2)
			w_adj[i] = gtk_adjustment_new(v_info[0].Saturation, 1, 128, 1, 1, 0);
		if(i ==3)
			w_adj[i] = gtk_adjustment_new(v_info[0].Hue, 1, 256, 1, 1, 0);
		
		gtk_signal_connect(GTK_OBJECT(w_adj[i]), "value_changed", GTK_SIGNAL_FUNC(ch_bscale), GINT_TO_POINTER(i));
		//range
		w_info_scale[i] = gtk_hscale_new(GTK_ADJUSTMENT(w_adj[i]));
		gtk_widget_set_usize(GTK_WIDGET(w_info_scale[i]), 90, 30);
		gtk_range_set_update_policy(GTK_RANGE(w_info_scale[i]), GTK_UPDATE_CONTINUOUS);
		gtk_scale_set_draw_value(GTK_SCALE(w_info_scale[i]), FALSE);

		gtk_box_pack_start(GTK_BOX (hbox1), w_info_scale[i], TRUE/*FALSE*/, /*TRUE*/FALSE, 0);
	}
	/********* end video info ***********/
	
	
	//capture	
	//frame = gtk_frame_new("¼");
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start(GTK_BOX(vbox1), frame, TRUE/*FALSE*/, /*TRUE*/FALSE, 0);

	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox2), 5);
	gtk_container_add(GTK_CONTAINER(frame), vbox2);
	
	hbox1 = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox1), 0);
	gtk_box_pack_start(GTK_BOX (vbox2), hbox1, TRUE/*FALSE*/, /*TRUE*/FALSE, 5);

	w_record_flag = gtk_check_button_new_with_label("Record");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w_record_flag), FALSE);
	gtk_box_pack_start(GTK_BOX(hbox1), w_record_flag, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_record_flag), "clicked",
			GTK_SIGNAL_FUNC(record_callback), NULL);
	//motion detect
	w_motion_detect_flag = gtk_check_button_new_with_label("MotionDetect");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w_motion_detect_flag), FALSE);
	gtk_box_pack_start(GTK_BOX(hbox1), w_motion_detect_flag, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_motion_detect_flag), "clicked",
			GTK_SIGNAL_FUNC(motion_detect_callback), NULL);
	
	hbox1 = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox1), 0);
	gtk_box_pack_start(GTK_BOX (vbox2), hbox1, TRUE/*FALSE*/, /*TRUE*/FALSE, 5);

	//audio preview
	w_audio_preview = gtk_check_button_new_with_label("AudioPreview");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w_audio_preview), FALSE);
	gtk_box_pack_start(GTK_BOX(hbox1), w_audio_preview, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_audio_preview), "clicked",
			GTK_SIGNAL_FUNC(audio_preview_callback), NULL);
	//net transfer
	w_net_transfer = gtk_check_button_new_with_label("NetTransfer");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w_net_transfer), FALSE);
	gtk_box_pack_start(GTK_BOX(hbox1), w_net_transfer, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_net_transfer), "clicked",
			GTK_SIGNAL_FUNC(net_transfer_callback), NULL);

	hbox1 = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox1), 0);
	gtk_box_pack_start(GTK_BOX (vbox2), hbox1, TRUE/*FALSE*/, /*TRUE*/FALSE, 5);

	//preview	
	w_preview = gtk_check_button_new_with_label("Preview");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w_preview), TRUE);	//active preview 
	//gtk_box_pack_start(GTK_BOX(vbox2), w_preview, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox1), w_preview, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_preview), "clicked",
			GTK_SIGNAL_FUNC(preview_callback), NULL);
	//string to client : test add at 2004.8
	w_stringtoclient = gtk_check_button_new_with_label("StringToClient");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w_stringtoclient), FALSE);
	gtk_box_pack_start(GTK_BOX(hbox1), w_stringtoclient, TRUE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w_stringtoclient), "clicked",
			GTK_SIGNAL_FUNC(stringtoclient_callback), NULL); 
	

	/* get original image */
	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox2), 0);
	gtk_box_pack_start(GTK_BOX (vbox1), vbox2, FALSE, FALSE, 0);
	w_image = gtk_button_new_with_label("Get Image");
	gtk_widget_set_usize(w_image, 120, 25);
	gtk_signal_connect (GTK_OBJECT (w_image), "clicked",
			GTK_SIGNAL_FUNC (process_buttons), GINT_TO_POINTER(3));
	gtk_box_pack_start(GTK_BOX (vbox2), w_image, TRUE,FALSE, 10);
	/* Capture a I frame */
	w_I_frame = gtk_button_new_with_label("Capture I Frame");
	gtk_signal_connect (GTK_OBJECT (w_image), "clicked",
			GTK_SIGNAL_FUNC (process_buttons), GINT_TO_POINTER(4));
	gtk_widget_set_usize(w_I_frame, 120, 25);
	gtk_box_pack_start(GTK_BOX (vbox2), w_I_frame, FALSE,FALSE, 0);
			
	/***********  exit ****************/
	hbox1 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox1), 0);
	gtk_box_pack_start(GTK_BOX (vbox1), hbox1, FALSE, FALSE, 5);
	w_buttons[2] = gtk_button_new_with_label(button_str[2]);
	gtk_signal_connect (GTK_OBJECT (w_buttons[2]), "clicked",
			GTK_SIGNAL_FUNC (process_buttons), GINT_TO_POINTER(2));
	gtk_box_pack_start(GTK_BOX (hbox1), w_buttons[2], FALSE, /*TRUE*/FALSE, 0);

	//initial datas
	memset(old_frames, 0, sizeof(old_frames));
	memset(current_frames, 0, sizeof(current_frames));
	memset(bit_rate_time, 0, sizeof(bit_rate_time));
	memset(bit_rate_size, 0, sizeof(bit_rate_size));
	memset(net_head_flag, 0, sizeof(net_head_flag));

	//setup timer 
	count_timer = g_timer_new();
	
	processtimer = gtk_timeout_add(1000/5, (GtkFunction)process_time, NULL);	/* 1/5s */
	looptimer = gtk_timeout_add(1000 * timeconst, (GtkFunction)process_time_loop, NULL); /* timeconst/60 minutes */
	watchtimer = gtk_timeout_add(1000 * 60, (GtkFunction)process_watchtime_loop, NULL); /* 1 minutes */

	gtk_widget_show_all(window);
	
	/* the sdl hack must set after the show */
        sprintf(SDL_windowhack, "SDL_WINDOWID=%ld", GDK_WINDOW_XWINDOW(w_full_area->window));
        putenv(SDL_windowhack);
	/* inital the sdl */
	XInitThreads();
        putenv("SDL_VIDEO_YUV_HWACCEL=0");
                                                                                                                             
        fprintf(stderr,"Init the sdl...");
        if(SDL_Init(SDL_INIT_VIDEO) < 0)
        {
                fprintf(stderr,"<sdk_error> init sdl failed!%s\n",SDL_GetError());
                return -1;
        }
        fprintf(stderr,"ok!\n");

        pOverlayScreen = SDL_SetVideoMode(WIN_W, WIN_H, 0, SDL_HWSURFACE);
        if(pOverlayScreen == NULL)
        {
                fprintf(stderr,"<sdk_error> create the sdl screen failed! for %s!\n", SDL_GetError());
                SDL_Quit();
                return -1;
        }
	/*SDL init finished*/


	for(i = 0; i < MAX_PORT; i++)
		count[i] = 0;

	if(InitDSPs() <= 0)	
	{
		printf("Initial DSP failed, error code 0x%x\n", GetLastErrorNum());
		exit(1);
	}
	//get total cards and ports
	totalcard = GetTotalDSPs();
	totalport = GetTotalChannels();

	//totalport = 4;	//debug

	printf("total cards = %d, total ports = %d\n", totalcard, totalport);
	
	limitsize =  timeconst * (totalport * fixsize) /1024; /* KB */
	printf("limit free space : %luKB\n", limitsize);
	
	//totalport = 1;//debug
	
	/* set logo */
	logoptr = (unsigned char *)malloc(128 * 32 * 2);
	memset(logoptr, 0, sizeof(logoptr));
	LoadYUVFromBmpFile("logo.bmp", logoptr, 128 * 32 * 2, &logo_w, &logo_h); 
	
		/* open channel */
	for(i = 0; i < totalport; i++)
	{
		if((ChannelHandle[i] = ChannelOpen(i, pStreamRead)) < 0)
		{
			fprintf(stderr, "open port %d failed\n", i);
			for(j = 0; j< i; j++)
				ChannelClose(ChannelHandle[j]);
			exit(1);
		}

		//SetStreamType(ChannelHandle[i], STREAM_TYPE_VIDEO);

		SetDefaultQuant(ChannelHandle[i],12,12,17);
	
		GetVideoPara(ChannelHandle[i],
		       &videostandard[i],	
			&v_info[i].Brightness, &v_info[i].Contrast, &v_info[i].Saturation, &v_info[i].Hue);
		SetOsdDisplayMode(ChannelHandle[i], 0xff, 1, 0x0000, format1, format2);
		
		/* yxq test at 2004.4.28*/
		SetOsd(ChannelHandle[i], 1);
		
#ifdef LOGO
		SetLogoDisplayMode(ChannelHandle[i], 0x0, 0x0, 0x0, 1, 0x2005);
		//SetLogoDisplayMode(ChannelHandle[i], 0x0, 0x0, 0x0, 1, 0);
 		if(videostandard[i] == StandardNTSC)	
			SetLogo(ChannelHandle[i], 576, 448, logo_w, logo_h, logoptr);
	        else
		       SetLogo(ChannelHandle[i], 576, 544, logo_w, logo_h, logoptr);
#endif		
		
		      
		AdjustMotionDetectPrecision(ChannelHandle[i], 2, 2, 0);	/* disable slow motion detect */
		//There is constant bit rate now! 
		
		
		SetBitrateControlMode(ChannelHandle[i], brc);

		SetStreamType(ChannelHandle[i], stream_type);
		
		if(videostandard[i] == StandardNTSC)
			video_height[i] = 480;
		else
			video_height[i] = 576;
	
	}

//set QCIF and 2CIF or CIFQCIF
	memset(qcif_flag, 0, sizeof(qcif_flag));
	memset(hcif_flag, 0, sizeof(hcif_flag));
	memset(cifqcif_flag, 0, sizeof(cifqcif_flag));

/*
	qcif_flag[0] = 1;
	qcif_flag[1] = 1;
	hcif_flag[2] = 1;
*/
	//cifqcif_flag[0] = 1;

	for(i = 0; i<totalport; i++){
		if(qcif_flag[i])
			SetEncoderPictureFormat(ChannelHandle[i], ENC_QCIF_FORMAT);
		else if(hcif_flag[i])
			SetEncoderPictureFormat(ChannelHandle[i], ENC_2CIF_FORMAT);
		else if(cifqcif_flag[i])
			{
				SetEncoderPictureFormat(ChannelHandle[i], ENC_CIFQCIF_FORMAT);
				SetupSubChannel(ChannelHandle[i], 1);
				SetIBPMode(ChannelHandle[i], 25, 0, 0, 25);
				SetupSubChannel(ChannelHandle[i], 0);
			}
		else  
			SetEncoderPictureFormat(ChannelHandle[i], ENC_CIF_FORMAT);

	}

	
	//SetIBPMode(ChannelHandle[0],25,0,0,1);
	

	/* get cardno */
	{
		unsigned int boardtype;
		char serialno[20], serialno_str[20];
		
		for(i = 0; i < totalport; i++)
		{
			GetBoardInfo(ChannelHandle[i], &boardtype, serialno);
			for(j = 0; j < 12; j++){
				serialno_str[j] = serialno[j] + 0x30;
			}
			serialno_str[j] = '\0';
			printf("card[%d]'s serialno = %s\n", i, serialno_str);
			
		}
	}

#if 1
	//get coordinate of video output window
	//and start preview
	gdk_window_get_deskrelative_origin(w_full_area->window,
			&full_win.x, &full_win.y);
	full_rect.x = 0;//full_win.x;
	full_rect.y = 0;//full_win.y;
	full_rect.w = full_win.w;
	full_rect.h = full_win.h;

	printf("full window at (%d, %d), w = %d, h = %d\n", full_win.x, full_win.y, full_win.w, full_win.h);
	int chan = 1;
	switch(totalport){
		case 1:
			chan = 1;
			break;
		case 2:
		case 3:
		case 4:
			chan = 2;
			break;
		case 5:
		case 6:
		case 7:
		case 8:
			chan = 3;
			break;
		default:
			chan = 4;
			break;
	}
		
	for(i = 0; i < totalport; i++)
	{
		v_win[i].w = full_win.w/chan;
		v_win[i].h = full_win.h/chan;
		dstRect[i].x = (i%chan) * v_win[i].w;
		dstRect[i].y =  (i/chan) * v_win[i].h;
		dstRect[i].w = v_win[i].w;
		dstRect[i].h = v_win[i].h;
		if(StartVideoPreview(ChannelHandle[i], pOverlayScreen, dstRect[i])<0)
			printf("start video preview(port %d) failed\n", i);
		//printf("port[%d]: (%d,%d), (%d,%d), full_win.w = %d, full_win.h = %d, chan = %d\n",i, dstRect[i].x, dstRect[i].y,dstRect[i].w,dstRect[i].h,full_win.w,full_win.h,chan);
		
		/* for motion detect */
		motion_list[i].RectLeft = (i%chan) * v_win[i].w;
		motion_list[i].RectTop =  (i/chan) * v_win[i].h;
		motion_list[i].RectRight =  (i%chan + 1) * v_win[i].w;
		motion_list[i].RectBottom =  (i/chan + 1) * v_win[i].h;
		motion_rect[i].RectLeft = 0;
		motion_rect[i].RectTop =  0;
		motion_rect[i].RectRight =  704 - 1;
		motion_rect[i].RectBottom =  video_height[i] -1 ;
		//printf("motion_list[%d]: (%d, %d), (%d, %d), w = %d, h = %d\n", i, motion_list[i].RectLeft,motion_list[i].RectTop,motion_list[i].RectRight,motion_list[i].RectBottom, v_win[i].w , v_win[i].h);
		//printf("motion_rect[%d]: (%d, %d), (%d, %d)\n", i, motion_rect[i].RectLeft,motion_rect[i].RectTop,motion_rect[i].RectRight,motion_rect[i].RectBottom);
		if(SetupMotionDetection(ChannelHandle[i], &motion_rect[i], 1) < 0)
			printf("setup motion detect(port %d) failed\n",i);
	}



	//get time
	now = time(NULL);
	tm = localtime(&now);
	strftime(timebuf, sizeof(timebuf), "%Y-%m-%d", tm);
	sprintf(starttime,"%s  ",timebuf);
	gtk_text_insert(GTK_TEXT(w_status[0]), NULL, NULL, NULL, timebuf, -1);
	strftime(timebuf, sizeof(timebuf), "%T", tm);
	strcat(starttime, timebuf);
	gtk_text_insert(GTK_TEXT(w_status[1]), NULL, NULL, NULL, timebuf, -1);
	
#endif				
	gtk_main();

	return 0;
}
